%e 5000
%p 20000
%n 2000
%k 5000
%a 20000
%o 20000

%start aa aaa bb cc hh ii  kk ll mm   
%start zz tt jj uu 
%start hpf 

%{

/***
 aa indicates the inquire_stmt
 bb indicates the open_stmt
 cc indicates the read_stmt
 dd indicates all the stmts beginning with "end"
 ee indicates the case_stmt
 ff indicates the type_declaration_stmt
 gg indicates the use_stmt
 hh indicates the write_stmt
 ii indicates the close_stmt
 jj indicates the allocate_stmt
 kk indicates the backspace_stmt
 ll indicates the endfile_stmt
 mm indicates the rewind_stmt
 nn indicates the if_stmt
 oo indicates the assign_stmt
 pp indicates the interface_stmt
 qq indicates the intent_stmt
 rr indicates the function_stmt and entry_stmt: result
 ss indicates the print_stmt
 tt indictats the beginning with the label
 zz indicates the format_stmt
 uu indicates the implicit_stmt
***/

#ifdef HAVE_CONFIG_H
#include <config.h>                     /* config header file */
#endif

#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>
#include "keywords.h"
#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"

#include "defnodes.h"
#include "hpfparser.tab.h"

/*extern char yytext[YYLMAX];  yytext[0x400] (sun20) ; *yytext  (Linux) */ 

extern  int  debugFlag_g,intrFlag_g;
extern  int  fixedFormat_g;
extern  int  lineNum_g,lineNum_l;
extern  FILE *inf_ptr;
int namelist=0,common=0,acimp=0,acimp1=0,branu=0;
int cont;
char *copys();

%}

Digit                           [0-9]
Letter                          [a-zA-Z]
Identifier                      ({Letter}|{Digit}|"_"|"$")
Name                            {Letter}{Identifier}*

BinaryConst                     [bB](\'[01]+\'|\"[01]+\")
OctalConst                      [oO](\'[0-7]+\'|\"[0-7]+\")
HexConst                        [zZ](\'[0-9a-fA-F]+\'|\"[0-9a-fA-F]+\")

DigitString                     {Digit}+

DefinedOperator                 ("."{Letter}+".")

SignedDigitString               [+-]?{DigitString}
Significand                     (({DigitString}"."{DigitString}?)|("."{DigitString}))

RealLiteralConstant             ({Significand}([Ee]{SignedDigitString})?|{DigitString}[eE]{SignedDigitString})

DoubleLiteralConstant           ({Significand}([Dd]{SignedDigitString})?|{DigitString}[dD]{SignedDigitString})

%%

%{
   yyin=inf_ptr;
					/* zheng.gb 1996.5.29 */
#ifdef YYTEXT_IS_POINTER
  #ifdef IS_UNSIGNED_CHAR
   yytext = (unsigned char *) calloc(1,(unsigned)0x400);
  #else
   yytext = (char *) calloc(1,(unsigned)0x400);
  #endif
#endif
%}

^[C*][ \t].*\n	 {
   int i=0;
   if(fixedFormat_g==1)
     {
      if(debugFlag_g==1)
           printf("(fixed_C)\n");
      lineNum_g++;
      lineNum_l++;
      }
   else
     { 
       do 
        {  i++;
           }while(yytext[i]!=' ');
       yyless(i);
       yytext[i]='\0';
       yylval.charp = copys(yytext);
       return(NAME);
     }
}

^[C*]\n  {
      lineNum_g++;
      lineNum_l++;
}

[ \t]	;

^[ \t]*"\n"  {
   lineNum_g++;
   lineNum_l++;
}

^[ \t]*!.*\n  {
   char  temp[160];
   strcpy(temp,yytext);
   temp[6]='\0';
   if(strcmp(temp,"!HPF$ ")==0)
    { 
      yyless(5);
      if(debugFlag_g==1)
          printf("(!hpf)");
      BEGIN hpf;
      }
   else
     {
      lineNum_g++;
      lineNum_l++;
      }
}

!.*\n  {
   if(debugFlag_g==1)
        printf("(commnet)");
   lineNum_g++;
   lineNum_l++;
   yylval.charp=copys(yytext);	
   return(COMMENT);
}

&[ \t]*\n  {
   lineNum_g++; 
   lineNum_l++;
   cont=1; 
}

&[ \t]*!.*\n   {
   lineNum_g++; 
   lineNum_l++;
   cont=1; 
}

^[ \t]*&  ;

^[ \t]*[0-9]{1,5}[ \t]+  {
    /* yytext[6]='\0'; */
   yylval.charp=copys(yytext);
   if(cont==1)
       return(DIGIT_STRING);
   if(debugFlag_g==1)
       printf("(label:%s)",yytext);
   BEGIN tt;	
   return(LABEL);
}


<hpf>[dD][iI][Mm][eE][nN][sS][iI][oO][nN]/"("   {
   return(DIRDIMENSION);
}

<hpf>[sS][eE][Qq][uU][eE][nN][Cc][eE]  {
   return(DIRSEQUENCE);
}


<zz>[Ii]/{DigitString} {
   if(debugFlag_g==1)
      printf("(f_i),");
   return(I);
}

<zz>[Bb]/{DigitString} {
   if(debugFlag_g==1)
     printf("(f_b),");
   return(B);
}

<zz>[oO]/{DigitString} {
   if(debugFlag_g==1)
       printf("(f_o),");
   return(O);
} 

<zz>[Zz]/{DigitString} {
   if(debugFlag_g==1)
       printf("(f_z),");
   return(Z);
}

<zz>[Ff]/{DigitString} {
   if(debugFlag_g==1)
       printf("(f_f),");
   return(F);
} 

<zz>[Ee]/{DigitString} {
   if(debugFlag_g==1)
       printf("(f_e),");
   return(E);
}

<zz>[Ee][Nn]/{DigitString} {
   if(debugFlag_g==1)
       printf("(f_en),");
   return(EN);
}

<zz>[Ee][Ss]/{DigitString} {
   if(debugFlag_g==1)
        printf("(f_es),");
   return(ES);
}

<zz>[gG]/{DigitString} {
   if(debugFlag_g==1)
       printf("(f_g),");
   return(G);
}

<zz>[lL]/{DigitString} {
   if(debugFlag_g==1)
       printf("(f_l),");
   return(L);
} 

<zz>[aA]      | 
<zz>[aA]/{DigitString} {
   if(debugFlag_g==1)
        printf("(f_a),");
   return(A);
}

<zz>[dD]/{DigitString} {
   if(debugFlag_g==1)
        printf("(f_d),");
   return(D);
} 

<zz>[pP]  {
   if(debugFlag_g==1)
       printf("(f_p),");
   return(P);
}

<zz>[tT]/{DigitString} {
   if(debugFlag_g==1)
        printf("(f_t),");
   return(T);
}

<zz>[Tt][Ll]/{DigitString} {
   if(debugFlag_g==1)
       printf("(f_tl),");
   return(TL);
}

<zz>[Tt][Rr]/{DigitString} {
   if(debugFlag_g==1)
      printf("(f_tr),");
   return(TR);
}

<zz>[Xx]  {
   if(debugFlag_g==1)
        printf("(f_x),");
   return(X);
}

<zz>[Ss]  {
   if(debugFlag_g==1)
        printf("(f_s),");
   return(S);
}

<zz>[Ss][Pp]  {
   if(debugFlag_g==1)
         printf("(f_sp),");
   return(SP);
}

<zz>[Ss][Ss]  {
   if(debugFlag_g==1)
        printf("(f_ss),");
   return(SS);
}

<zz>[bB][nN]  {
   if(debugFlag_g==1)
       printf("(f_bn),");
   return(BN);
}

<zz>[Bb][Zz]  {
   if(debugFlag_g==1)
        printf("(f_bz),");
   return(BZ);
}

<zz>[hH][^,)]*  {
   if(debugFlag_g==1)
        printf("(fh_ %s ),",yytext);
   yylval.charp=copys(yytext);
   return(H);
}

<aa,bb>[aA][cC][cC][eE][sS][sS][ ]*[=]  {
   return(ACCESSL);
}

<aa,bb>[aA][cC][tT][iI][oO][nN][ ]*[=]  {
   return(ACTION);
}

<cc,hh>[aA][dD][vV][aA][nN][cC][eE][ ]*[=]	 {
   return(ADVANCE);
}

<cc,hh>"("	 {
   branu++;
   if(debugFlag_g==1)
         printf("(lb<cc,hh>),");
   return(LEFTBRACKET);
}

<cc,hh>")"	 {
   branu--;
   if(debugFlag_g==1)
        printf("(rb),");
   if(branu==0)
        BEGIN 0;
   return(RIGHTBRACKET);
}

<cc,hh>","	 {
   if(debugFlag_g==1)
       printf("(com2),");
   return(COMMA2);
}

<aa,bb>[bB][lL][aA][nN][kK][ ]*[=]  {
   return(BLANK);
}

<aa,bb>[dD][eE][lL][iI][mM][ ]*[=]	 {
   return(DELIM);
}

<aa>[dD][iI][rR][eE][cC][tT][ ]*[=]	 {
   return(DIRECT);
}

<cc>[eE][nN][dD][ ]*[=]  {
   return(ENDR);
}

<aa,bb,cc,hh,ii,kk,ll,mm>[eE][rR][rR][ ]*[=]	 {
   return(ERR);
}

<aa>[eE][xX][iI][sS][tT][ ]*[=]	 {
   return(EXIST);
}

<bb,ii>[sS][tT][aA][tT][uU][sS][ ]*[=]	 {
   return(STATUS);
}

<aa>[rR][eE][aA][dD][wW][rR][iI][tT][eE][ ]*[=]	 {
   return(READWRITE);
}

<aa>[iI][oO][lL][eE][nN][gG][tT][hH][ ]*[=]	 {
   BEGIN 0;
   BEGIN aaa;
   return(IOLENGTH);
}

<aa,bb,cc,hh,ii,kk,ll,mm>[iI][oO][sS][tT][aA][tT][ ]*[=]  {
   return(IOSTAT);
}

<aa>[wW][rR][iI][tT][eE][ ]*[=]  {
   return(WRITEI);
}

<aa>[uU][nN][fF][oO][rR][mM][aA][tT][tT][eE][dD][ ]*[=] {
   return(UNFORMATTED);
}

<aa,bb,cc,hh,ii,kk,ll,mm>[uU][nN][iI][tT][ ]*[=] {
   return(UNIT);
}

<aa>[sS][eE][qQ][uU][eE][nN][tT][iI][aA][lL][ ]*[=] {
   return(SEQUENTIAL);
}

<cc>[sS][iI][zZ][eE][ ]*[=]	 {
   return(SIZE);
}

<cc,hh>[rR][eE][cC][ ]*[=]	 {
   return(REC);
}

<aa,bb>[rR][eE][cC][lL][ ]*[=]	 {
   return(RECL);
}

<aa>[rR][eE][aA][dD][ ]*[=]	 {
   return(READI);
}

<aa,bb>[pP][oO][sS][iI][tT][iI][oO][nN][ ]*[=]	 {
   return(POSITION);
}

<aa,bb>[pP][aA][dD][ ]*[=]	 {
   return(PAD);
}

<aa>[oO][pP][eE][nN][eE][dD][ ]*[=]	 {
   return(OPENED);
}

<aa>[nN][uU][mM][bB][eE][rR][ ]*[=]	 {
   return(NUMBER);
}

<aa>[nN][eE][xX][tT][rR][eE][cC][ ]*[=]	 {
   return(NEXTREC);
}

<cc,hh>[nN][mM][lL][ ]*[=]	 {
   return(NML);
}

<aa>[nN][aA][mM][eE][ ]*[=]	 {
   return(NAMEI);
}

<aa>[nN][aA][mM][eE][dD][ ]*[=]	 {
   return(NAMED);
}

<cc>[eE][oO][rR][ ]*[=]	 {
   return(EOR);
}

<aa,bb>[fF][iI][lL][eE][ ]*[=]	 {
   return(FILEI);
}

<cc,hh>[fF][mM][tT][ ]*[=]	 {
   return(FMT);
}

<aa,bb>[fF][oO][rR][mM][ ]*[=]	 {
   return(FORM);
}

<aa>[fF][oO][rR][mM][aA][tT][tT][eE][dD][ ]*[=]	 {
   return(FORMATTED);
}

<jj>[sS][tT][aA][tT][ ]*[=]	 {
   return(STAT);
}


^[ \t]*[rR][eE][aA][lL]  {
   if(cont==1)
       return(FUNNAME); 
   else
      return(REAL);
}

<uu>[rR][eE][aA][lL]  {
   if(debugFlag_g==1)
       printf("(real<uu>)");
   return(REAL);
}

<uu>"("[ ]*{Letter}[ ]*(","|"-"|")") {
   if(debugFlag_g==1)
        printf("(lb2<uu>)");
   yyless(1);
   return(LEFTBRACKET2);
}

<uu>{Letter}  {
   if(debugFlag_g==1)
        printf("(implicit_letter %s)",yytext);
   return(IMPLICITLETTER);
}

[kK][iI][nN][dD][ ]*[=]  {
   if(debugFlag_g==1)
       printf("(kind=)");
   return(KINDEQ);
}

[lL][eE][nN][ ]*[=]      {
   if(debugFlag_g==1)
        printf("(len=)");
   return(LENEQ);
}

[dD][oO][uU][bB][lL][eE][ ]*[pP][rR][eE][cC][iI][sS][iI][oO][nN]  {
   return(DOUBLEPRE);
}

[bB][lL][oO][cC][kK][ ]*[dD][aA][tT][aA]  {
   return(BLOCKDATA);
}

[iI][nN][ ]*[oO][uU][tT]  {
   return(INOUT);
}

[gG][oO][ ]*[tT][oO]  {
   return(GOTO);
}

[sS][eE][lL][eE][cC][tT][ ]*[cC][aA][sS][eE]  {
   return(SELECTCASE);
}

[eE][lL][sS][eE][ ]*[wW][hH][eE][rR][eE] {
   return(ELSEWHERE);
}

[eE][lL][sS][eE][ ]*[iI][fF][ (]  {
   yyless(yyleng-1);
   return(ELSEIF);
}

[eE][nN][dD][ ]*[dD][oO]  {
   return(ENDDO);
}

[eE][nN][dD][ ]*[iI][fF]  {
   return(ENDIF);
}

[eE][nN][dD][ ]*[sS][eE][lL][eE][cC][tT]  {
   return(ENDSELECT);
}

[eE][nN][dD][ ]*[wW][hH][eE][rR][eE]  {
   return(ENDWHERE);
}

[eE][nN][dD][ ]*[fF][oO][rR][aA][lL][lL]  {
   return(ENDFORALL);
}

[eE][nN][dD][ ]*[Tt][yY][pP][eE]  {
   return(ENDTYPE);
}

[eE][nN][dD][ ]*[iI][nN][tT][eE][rR][fF][aA][cC][eE]  {
   return(ENDINTERFACE);
}

[eE][nN][dD][ ]*[mM][oO][dD][uU][lL][eE]  {
   return(ENDMODULE);
}

[eE][nN][dD][ ]*[bB][lL][oO][cC][kK][ ]*[dD][aA][tT][aA]  {
   return(ENDBLOCKDATA);
}

[eE][nN][dD][ ]*[sS][uU][bB][rR][oO][uU][tT][iI][nN][eE]  {
   return(ENDSUBROUTINE);
}

[eE][nN][dD][ ]*[fF][uU][nN][cC][tT][iI][oO][nN]  {
   return(ENDFUNCTION);
}

[eE][nN][dD][ ]*[pP][rR][oO][gG][rR][aA][mM] {
   return(ENDPROGRAM);
}


"."[fF][aA][lL][sS][eE]"."  {
   return(FALSEL);
}

"."[tT][rR][uU][eE]"."   { 
   return(TRUEL);
}

"."[eE][qQ][vV]"."  {
   return(EQV);
}

"."[nN][eE][qQ][vV]"."  {
   return(NEQV);
}

"."[oO][rR]"."  {
   return(OR);
}

"."[aA][nN][dD]"."  {
   return(AND);
}

"."[nN][oO][tT]"."  {
   return(NOT);
}

"."[eE][qQ]"."  {
   return(EQ);
}

"=="  {
   return(EQ);
}

"."[nN][eE]"."  {
   return(NE);
}

"/="  {
   return(NE);
}

"."[lL][tT]"."  {
   return(LT);
}

"<"  {
   return(LT);
}

"."[lL][eE]"."  {
   return(LE);
}

"<="  {
   return(LE);
}

"."[gG][tT]"."  {
   return(GT);
}

">"  {
   return(GT);
}

"."[gG][eE]"."  {
   return(GE);
}

">="	 {
   return(GE);
}

"=>"  {
   if(debugFlag_g==1)
        printf("(=>)");
   return(EQGT);
}	

":"  {
   return(COLON);
}

";"  {
   if(debugFlag_g==1)
         printf("(;)"); 
   BEGIN 0;
   BEGIN aa;
   BEGIN bb;
   return(CARRIAGE2);
}

"?"  {
   return(QUESTION);
}

"="  {
   if(debugFlag_g==1)
        printf("(=)");
   return(EQUAL);
}

"::"   {
   return(DOUBLECOLON);
}

"_"    {
   return(UNDERSCORE);
}

"_'"   {
   yyless(yyleng-1);
   if(debugFlag_g==1)
       printf("(_1),");
   return(UNDERSCORE1);
}

"_"\"	 {
   yyless(yyleng-1);
   if(debugFlag_g==1)
         printf("(_1),");
   return(UNDERSCORE1);
}

","[ ]*"/"  {
  if(common==1 || namelist==1)
   {
     yyless(yyleng-1);
     return(COMMA1);
     }
   else
   {
     yyless(yyleng-1);
     return(COMMA);
     }
}

"\n"  {
   common=0;
   namelist=0;
   cont=0;
   if(debugFlag_g==1)
       printf("(car)\n");
   BEGIN 0;
   return(CARRIAGE1);
}

"%"  {
   if(debugFlag_g==1)
         printf("(%),");
   return(PERCENT);
}

","  {
   if(debugFlag_g==1)
         printf("(,),");
   return(COMMA);
}

"."  {
   if(debugFlag_g==1)
        printf("(.),");
   return(FULLPOINT);
}

\"[^"]*\"  {
   if(debugFlag_g==1)
         printf("(dqstr),");
   yylval.charp=copys(yytext);
   return(STRING);
}

\'[^']*\'  {
   if(debugFlag_g==1)
         printf("(sqstr),");
   yylval.charp=copys(yytext);
   return(STRING);
}

"("  {
   int i,j;
   char chara,cha_arr[80];

   if(acimp==1)
    { 
      i=1;j=0;
      while(i!=0)
        { 
          chara=input();
          if(chara=='(')
 		i++;
          if(chara==')')
		i--;
          cha_arr[j++]=chara;
          if(chara=='=')
             {
         	acimp1=1;
		break;
  		}
	  }
       j--;		
       for(j;j>=0;j--)
           unput(cha_arr[j]);	
       if(acimp1==1)		
        { 
          acimp1=0;		
          if(debugFlag_g==1)
              printf("(lb1),");
          return(LEFTBRACKET1);
          }
    	else
          { 
            if(debugFlag_g==1)
               printf("(lb),");
            return(LEFTBRACKET);
            }
        }
   else 
   { 
         if(debugFlag_g==1)
           printf("(lb),");
         return(LEFTBRACKET);
    }
}

"(//"    {
   yyless(1);
   return(LEFTBRACKET);
}

"(/"	 {
   acimp=1; 
   return(ACVALUE1);
}

")"	 {
   if(debugFlag_g==1)
          printf("(rb),");
   return(RIGHTBRACKET);
}

"+"	 {
   if(debugFlag_g==1)
        printf("(+),");
   return(PLUS);
}

"-"	 {
   if(debugFlag_g==1)
        printf("(-),");
   return(MINUS);
}

"*"	 {
   if(debugFlag_g==1)
        printf("(*),");
   return(MULTIPLY);
}

"/"	 {
   if(debugFlag_g==1)
        printf("(/),");
   return(DIVIDE);
}

"/)"	 {
   acimp=0;
   return(ACVALUE2);
}

"**"	 {
   if(debugFlag_g==1)
       printf("(**),");
   return(POWER);
}

"//"	 {
   if(common==1)
     { yyless(yyleng-1);
       return(DIVIDE);
       }
   else
      return(CONCAT);
}

{RealLiteralConstant}	 {
   yylval.charp=copys(yytext);
   return(REAL_LITERAL_CONST);
}

{DoubleLiteralConstant} {
   yylval.charp=copys(yytext);
   return(DOUBLE_LITERAL_CONST);
}

{Name} {
   return(keynameDeal_m(yytext));
}

{BinaryConst} {
   return(BINARY_CONST);
}

{OctalConst} {
   return(OCTAL_CONST);
}

{HexConst} {
   return(HEX_CONST);
}

{DigitString}	 {
   yylval.charp=copys(yytext);
   if(debugFlag_g==1)
        printf("(Digit %s)\n",yytext);
   return(DIGIT_STRING);
}

{DefinedOperator}	 {
   yylval.charp=copys(yytext);
   return(DEFINED_OPERATOR);
}

%%
yywrap()
{
  return(1);
}


/*******  "nameCmp_m" : if equl then return 0; nequl return 1  ********/

/*    int nameCmp_m(char buf1[35],char buf2[35])   */
int nameCmp_m(buf1,buf2)
char buf1[35];
char buf2[35];
{
   int i=0;
   int len1,len2;

   len1=strlen(buf1);
   len2=strlen(buf2);
   if(len1!=len2)return 1;

   do
    {
      if (buf1[i]!=buf2[i]&&buf1[i]-32!=buf2[i]&&buf1[i]!=buf2[i]-32)
           return 1;
        else i++;
     }while(i!=len1);
   return 0;
   }


/*********  "searchKey_m" : if find the keyword or funcname return it's
            index , else return limit         ***********/

/*   int searchKey_m(char name[35],char tab[120][35],int limit)  */
int searchKey_m(name,tab,limit)
char name[35];
char tab[120][35];
{
   int i=0;
   int flag=0;

   do
    {
        if(nameCmp_m(name,tab[i])==0)
            flag=1;
        else
             i++;
    }while (!((flag==1)||(i==limit))) ;
    return(i);
}

/*   int keynameDeal_m(char name[35])   */
int keynameDeal_m(name)
char name[35];
{
   int i;
   int returnValue_m;
   char chara;

   yylval.charp=copys( name ); 
   if((i=searchKey_m(name,FUNC_TAB_G,FUNC_TAB_LIMIT_G))<FUNC_TAB_LIMIT_G)
        {
/* return (NAME);                                 zheng.gb 1996.5.30 */
	 if (intrFlag_g ==1) return (NAME);
	 do {
             chara=input();
             }while(chara==' ');
         if(chara=='(')                 /*** "funname( )" : FUNNAME  ***/
               { unput(chara);
       	 	 if(debugFlag_g==1)
       	      		printf("(func_name: %s  %d)\n",name,i);
                 return(FUNNAME);
               }
          else 
               { unput(chara);
                 return(NAME);
               }
        }
   else
        { 
         if((i=searchKey_m(name,KEY_WORD_G,KEY_WORD_LIMIT_G))<KEY_WORD_LIMIT_G)
             { 
	       if(debugFlag_g==1)
                     printf("(keyword: %s  %d)\n",name,i);
               switch(i){
	        case 0:  BEGIN zz;    /* format */
                         break;
		case 1:
                case 2:  BEGIN jj;    /* (de)allocate */
                         break;
                case 3:  common=1;    /* common */
                         break;
                case 4:  namelist=1;  /* namelist */
                         break;
                case 5:  	    /*character */
                         break;
                case 6:  BEGIN bb;    /*  open  */
                         break;
                case 7:               /*  read  */
			 do {
			     chara=input();
			 }while(chara==' ');
                         if(chara=='(')
			      BEGIN cc;
                         unput(chara);
                         break;
                case 8:  BEGIN hh;    /*  write */
                         break;
                case 9:  BEGIN mm;    /* rewind */
                         break;
                case 10: BEGIN kk;    /*backspace*/
                         break;
                case 11: BEGIN ll;    /*endfile */
                         break;
		case 12: BEGIN ii;    /* close  */
			 break;
		case 13: BEGIN aa;    /* inquire */
			 break;
		case 14:              /* integer */
		case 15:              /* logical */
		case 16:              /* complex */
			 break;
                case 17: BEGIN uu;    /* implicit */
                         break;
                default: ;
                }
		/* returnValue_m=257+i; */
		returnValue_m=FORMAT+i;    /* modified by zheng.gb */
                return(returnValue_m);   
              }
         else
             {
               if(debugFlag_g==1) 
                   printf("(It's a name: %s)\n",name);
               return(NAME);
               }
        }
}
