/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993                  */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/

/* Modified by Jenq-Kuen Lee Feb 24,1988	  */
/* The simple un-parser for VPC++		  */
#include <stdio.h>
#include <stdlib.h>

#include "compatible.h"
#ifdef SYS5
#include <string.h>
#else
#include <strings.h>
#endif
 
# include "db.h"
# include "vparse.h"

# define NULLTEST(VAR)	(VAR == NULL? -1 : VAR->id)
# define type_index(X)	(X-T_INT)
# define binop(n)	(n >= EQ_OP && n <= NEQV_OP)
# define BUFLEN 	200000

extern PTR_SYMB	cur_symb_head;	/* point to the head of the list of symbols */
extern char buffer[], *bp;

static int	first;
static int	global_tab;
static char	buffera[BUFLEN];
static char	temp_buf[BUFLEN]; /* for temporary usage */
static char	temp1_buf[BUFLEN];
static char	temp2_buf[BUFLEN]; /* for temporary usage */
static char     args_buf[BUFLEN];       /* To be used as the bridge from the real arguments to the dull a
					rguments in Java , Added by Zheng Qiang*/
static int      in_var_decl_stmt = 1; /* 1 if the unparse process is in the declaration part
                                   	and 0 if in the execution part, Added by Zheng Qiang*/

  /** If TRUE,then current llnd node is for subString -- Wu Zhigang ***/
/*the following is added to f2j by wf*/
/**
#define ARR_DIME 20
#define DIME_LEN 20
static char low_dim_array[ARRAY_DIME][DIME_LEN];
static char high_dim_array[ARRAY_DIME][DIME_LEN];
static char current_posi[ARRAY_DIME][DIME_LEN];
char  temp[100]
#define ARR_DIME 200
static int low_dim_array[ARR_DIME];
static int high_dim_array[ARR_DIME];
static int lengh_of_dim[ARR_DIME];
static int cur_position[ARR_DIME];
*/


static int in_subString_val = 0;
static int in_StringConcat = 0;/* if True,then current llnd node is for concat*/
static int in_write_state = 0; /* if True,then current llnd node belongs to write statement */
static int in_read_state = 0; /* if True,then current statement is read_state*/
char *FormatSource = NULL; /* format statement's string */
char *sFormatStr=NULL; /* current format statement's string position */
static int tab_count = 0; /* save current statement's table keys */
static int bCommonNotInitiated = 1; /* indicate whether common statement is over */
static int in_common_state = 0; /* if 1,then indicates common statement initiate            ;if 2,then its common statement in function */
static int in_var_decl_deleted = 0; /* if true then the variable has been                        deleted,used in dealing with var's declaration which belongs                    to common statement */
static int in_equi_state = 0; /* if TRUE,then it's equivalence statement */
int FirstEquiVar = 1; /* if false,then it's the first var in the statement */

int in_return_state = 0; /* if TRUE,then it's return statement */ 

#define NONAME_COMMON_LENGTH 20
/*
char noname_var[NONAME_COMMON_LENGTH][20];
static int noname_common_offset = 0;
*/
  /* total count of common statements permitted */ 
#define COUNT_OF_COMMON 15 
char *NamedCommon[COUNT_OF_COMMON];/* stores common areas's classes */
static int count_of_common=0; /* current common statements' count */
static int current_common = 0;/* current common statement's number */
#define NAMED_COMMON_LENGTH 10
char *CommonName_var[COUNT_OF_COMMON][NAMED_COMMON_LENGTH];/* member variable name */
char *CommonName[COUNT_OF_COMMON]; /* common areas' names */
static int nFreeFlag[COUNT_OF_COMMON]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
static int Common_Offset[COUNT_OF_COMMON] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
/* static int bFirstCommon[COUNT_OF_COMMON] = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
 */
#define COMMON_BUFFER_LEN 200
 /* common area's name length */
#define NAMELEN 15



static int basket_needed();
static void updat_real_arg(); /* a new function added by Zheng Qiang */

/*
 * forward references
 */
static void cunp_blck();
static void gen_simple_type();
static void  gen_func_hedr();
static PTR_SYMB find_declarator();
static void cunp_llnd();

void gen_class_var_decl(); /* A new function added by Zheng Qiang */
extern PTR_SYMB findFuncDeclSymb(); /* A new function added by Zheng Qiang in file reform.c*/

static
char *cop_name[] = {
	"->",	    /* 0  */
	"!",	    /* 1  */
	"~",	    /* 2  */
	"++",	    /* 3  */
	"--",	    /* 4  */
	"-",	    /* 5  */
	"*",	    /* 6  */
	"&",	    /* 7  */
	"sizeof ",  /* 8  */
	"*",	    /* 9  */
	"/",	    /* 10 */
	"%",	    /* 11 */
	"+",	    /* 12 */
	"-",	    /* 13 */
	">>",	    /* 14 */
	"<<",	    /* 15 */
	"<",	    /* 16 */
	">",	    /* 17 */
	"<=",	    /* 18 */
	">=",	    /* 19 */
	"==",	    /* 20 */
	"!=",	    /* 21 */
	"&",	    /* 22 */
	"^",	    /* 23 */
	"|",	    /* 24 */
	"&&",	    /* 25 */
	"||",	    /* 26 */
	"=",	    /* 27 */
	"+=",	    /* 28 */
	"-=",	    /* 29 */
	"&=",	    /* 30 */
	"|=",	    /* 31 */
	"*=",	    /* 32 */
	"/=",	    /* 33 */
	"%=",	    /* 34 */
	"^=",	    /* 35 */
 	"<<=",	    /* 36 */
	">>="	    /* 37 */
};


/* Added for VPC */
static
char *ridpointers[] = {
	"",			/* unused */
	"",			/* int */
	"char", 		/* char */
	"float",		/* float */
	"double",		/* double */
	"void", 		/* void */
	"",			/* unused1 */
	"unsigned",		/* unsigned */
	"short",		/* short */
	"long", 		/* long */
	"auto", 		/* auto */
	"static",		/* static */
	"extern",		/* extern */
	"register",		/* register */
	"typedef",		/* typedef */
	"signed",		/* signed */
	"const",		/* const */
	"volatile",		/* volatile */
	"syn",			/* syn */
	"shared",		/* shared */
	"private",		/* private */
	"future",		/* future */
	"virtual",		/* virtual */
	"inline",		/* inline */
	"friend",		/* friend */
	"",			/* public */
	"",			/* protected */
};

/* Added for VPC */
static int
re_map_status(rid_value)
	int rid_value;
{
	switch (rid_value) {

	/* The following flag store in type->entry.descriptive.long_short_flag */
	case (int) BIT_PRIVATE: return((int)RID_PRIVATE);
	case (int) BIT_FUTURE:	return((int)RID_FUTURE);
	case (int) BIT_VIRTUAL: return((int)RID_VIRTUAL);
	case (int) BIT_INLINE:	return((int)RID_INLINE);

	case (int) BIT_UNSIGNED:return((int)RID_UNSIGNED);
	case (int) BIT_SIGNED : return((int)RID_SIGNED);


	case (int) BIT_SHORT :	return((int)RID_SHORT);
	case (int) BIT_LONG :	return((int)RID_LONG);


	case (int) BIT_VOLATILE:return((int)RID_VOLATILE);
	case (int) BIT_CONST   :return((int)RID_CONST);

	case (int) BIT_TYPEDEF :return((int)RID_TYPEDEF); 
	case (int) BIT_EXTERN  :return((int)RID_EXTERN);
	case (int) BIT_AUTO :	return((int)RID_AUTO);
	case (int) BIT_STATIC : return((int)RID_STATIC);
	case (int) BIT_REGISTER:return((int)RID_REGISTER);
	case (int) BIT_FRIEND:	return((int)RID_FRIEND);
	default:
		return(0);
	}
}


static void
put_tabs(n)
	int n;
{
	int i;

	for(i = 0; i < n; i++) {
		*bp++ = ' ';
		*bp++ = ' ';
	}
}


static void
addstr(s)
	char *s;
{
	while(*bp = *s++)
		bp++;
}


static void
addstr1(index)
	int index ;
{
	int i;

	i = re_map_status(index);
	if (i) {
		addstr(ridpointers[i]) ;
		*bp++ = ' ';
	}
}



static void
put_right(s, temp_buf)
	char *s ;
	char *temp_buf;
{
	int len,i ;
	char *p;
      
	i=0;
	len = strlen(temp_buf) ;
	for ( p = s ; *p ; p++,i++)
		*(temp_buf + len+ i) = *p ;
	*(temp_buf+len+i+1) = '\0';
}


static void
put_left(s, temp_buf)
	char *s ;
	char *temp_buf;
{
	int i ;
	int len1 ,len2;  

	len1 = strlen(s);
	len2 = strlen(temp_buf) ;
	*(temp_buf+len2+len1) = '\0';
	for ( i=len2 ; i ; i--)
		*(temp_buf + len1+ i-1) = *(temp_buf + i -1 );
	for ( i=0; *s ; i++,s++)
		*(temp_buf + i ) = *s ;

}


static void
clean(temp_buf)
	char *temp_buf;
{
	char *p;

	for (p = temp_buf ; p < temp_buf+BUFLEN ;)
		*p++ = '\0';
}


/*
 * gen_if_node(pbf) --- generate the if statement pointed to by pbf.
 */
static void
gen_branch(branch_type, pbf)
	char	       *branch_type;
	PTR_BFND	pbf;
{
	PTR_BFND	gen_stmt_list();
	addstr(branch_type);
	*bp++ = '(';
	cunp_llnd(pbf->entry.Template.ll_ptr1);
	*bp++ = ')';
}


static void
gen_descriptive_type(symb1)
	PTR_SYMB symb1 ;
{
	int i;
	PTR_TYPE q ;

	for (q = symb1->type; q ;   ) { 
		switch ( q->variant) {
		case T_POINTER : 
		case T_FUNCTION :
			q = q->entry.Template.base_type ;
			break;
		case T_DESCRIPT :
			for (i=1; i< MAX_BIT; i= i*2)
				addstr1(q->entry.descriptive.long_short_flag & i);
			q = q->entry.descriptive.base_type ;
			break ;
		default:	/* It might need more for complicated case */
			q = (PTR_TYPE) NULL ;
		}
	}


} 


static void
cunp_bfnd(tabs,pbf)
	int tabs;
	PTR_BFND     pbf;
{
	PTR_BFND	pbfnd, pnext;
	PTR_SYMB	s;
	int		i;
	int		lines;
        PTR_CMNT cmnt;
	if (!pbf) return;
	/* printf("variant = %d\n", pbf->variant); */
        if (cmnt = pbf->entry.Template.cmnt_ptr)
                while (cmnt != NULL && cmnt->type == FULL) {
                        addstr(cmnt->string);
                        addstr("\n");
                        cmnt = cmnt->next;
                }    

	if (pbf->label) {
		char b[10];
		if (pbf->variant != FORMAT_STAT)/* added by Wu Zhigang */
		{
		 /* sprintf(b ,"%-5d ", pbf->label->stateno); */
		 sprintf(b ,"j%-5d ", pbf->label->stateno);
		 addstr(b);
		 addstr(":"); /* added by Zheng Qiang to fit for Java */
		 }
	}
	if (pbf->variant != FORMAT_STAT) 
	 {
	 put_tabs(tabs);
	 tab_count = tabs; /* added by Wu Zhigang to save count of table key */
	 }
	if (bCommonNotInitiated == 1) /* if the noname common statement not over */
	  {/* added by Wu Zhigang */
	  PTR_BFND pbfnd = pbf;
	  int num;
	  /* addstr(" import java.io.*;\n"); */
	   while (1)
	   {
	    if  (pbfnd == NULL)
		break;
	      else
		if (pbfnd->variant == CONTROL_END)
		  {
			int com;
			bCommonNotInitiated = 0;
			for(com = 0;com < NAMED_COMMON_LENGTH;com++)
			  Common_Offset[com] = 0;
		        pbfnd = pbfnd->thread;
			current_common = 0;
		 }
		 else
		  if (pbfnd->variant != COMM_STAT)
		    pbfnd = pbfnd->thread;	 
		 else
		   {
		   cunp_llnd(pbfnd->entry.Template.ll_ptr1);	
		   pbfnd = pbfnd->thread; 
		   } /* end of if */
	     } /* end of while */	
	   bCommonNotInitiated = 0;
	   /* in_common_state = 2; */
	   for(num = 0;num<count_of_common;num++)
		{
		int flag;
		strcat(NamedCommon[num],"}\n");
		addstr(NamedCommon[num]);
		free(NamedCommon[num]);/* free buffer */
		for(flag = 0;flag<nFreeFlag[num];flag++)
		  free(CommonName_var[num][flag]); /* free buffer */
		free(CommonName[num]);
		}
	    /* addstr("}\n"); */
	
	  }
	switch (pbf->variant) {
	case GLOBAL	:
	case PROG_HEDR	:
	case PROC_HEDR	:
		break ;
	case FUNC_HEDR	:
                clean(args_buf);
                gen_class_var_decl(tabs,pbf);
		/*noname_common_offset = 0;  reset to 0 */
		{
		int sequen;
		for(sequen = 0;sequen < count_of_common;)
		 Common_Offset[sequen++] = 0;
		}
                addstr(" public static "); /*the above three line is added by Zheng Qiang */
		gen_simple_type(pbf->entry.Template.symbol->type, pbf, tabs);
		gen_func_hedr(pbf->entry.Template.symbol, pbf, tabs);
		break;
	case IF_NODE	:
		gen_branch("if ",pbf);
		break;
	case LOGIF_NODE :
	case ARITHIF_NODE:
	case WHERE_NODE :
		break;
	case FOR_NODE	:
		addstr("for (");
		cunp_llnd(pbf->entry.Template.ll_ptr1);
		*bp++ = ';';
		cunp_llnd(pbf->entry.Template.ll_ptr2);
		*bp++ = ';';
		cunp_llnd(pbf->entry.Template.ll_ptr3);
		addstr(") ") ;
		break;
	case FORALL_NODE	:
	case WHILE_NODE :
		addstr("while (");
		cunp_llnd(pbf->entry.Template.ll_ptr1);
		addstr(") ") ;
		break;
	case ASSIGN_STAT:
	case IDENTIFY:
	case PROC_STAT	:
	case SAVE_DECL:
	case CONT_STAT:
	case FORMAT_STAT:
		break;
	case LABEL_STAT:
		addstr(pbf->entry.Template.lbl_ptr->label_name->ident);
		addstr(" : ");
		break;
	case GOTO_NODE:
		addstr("break ");
		addstr(pbf->entry.Template.lbl_ptr->label_name->ident);
		addstr(" ;");
		break;
	case ASSGOTO_NODE:
	case COMGOTO_NODE:
	case STOP_STAT:
                if (pbf->entry.Template.ll_ptr1) {
                	addstr("return(");
                        cunp_llnd(pbf->entry.Template.ll_ptr1);
                        addstr(");");
                }
		else {
			addstr("return;");
		}
                break;
	case RETURN_STAT:
		if (pbf->entry.Template.ll_ptr1) {
			addstr("return(");
			cunp_llnd(pbf->entry.Template.ll_ptr1);
			addstr(");"); 
		}
		else {
			addstr("return;");
		}/* Modified by Zheng Qiang */
		break;
	case PARAM_DECL :/* added by Wu Zhigang for String Const */
		cunp_llnd(pbf->entry.Template.ll_ptr1);
		break;
	case DIM_STAT:
		
                /* added by wufei */
	        in_var_decl_stmt=1;
	        cunp_llnd(pbf->entry.Template.ll_ptr1->entry.Template.ll_ptr1);
                in_var_decl_stmt=0;
				addstr(";");
				break;
       
	case EQUI_STAT: /* added by Wu Zhigang */
	 /* at present condition,I only implemented array and array items */
	  in_equi_state  = 1; /* set flag 1 */
	  cunp_llnd(pbf->entry.Template.ll_ptr1);
	  in_equi_state = 0;
	  break;
	
	case DATA_DECL:
		break;
	case READ_STAT:
		in_read_state = 1;
		 /* Only need to deal with variable.That is,variable's type can be got through variable's type */
		cunp_llnd(pbf->entry.Template.ll_ptr2);
		/*bp--;* delete last '+' */
		in_read_state  = 0;
		break;		
	case WRITE_STAT:/* added by Wu Zhigang */
		in_write_state=1;
		addstr("System.out.println(");
		cunp_llnd(pbf->entry.Template.ll_ptr2);
		bp--; /* delete ',' */
		in_write_state = 2;
		cunp_llnd(pbf->entry.Template.ll_ptr3);
		in_write_state=0;
		 
                if (*sFormatStr != '\0' && sFormatStr != NULL)
		 {/* deal with the left part of format statement */
		int NotFinished = 1;/* Whether current part is finished */
	      while (NotFinished) {
		NotFinished = 0; 		
		while (*sFormatStr == ' ')sFormatStr++;
		if (*sFormatStr == '\'')
		  {/* if string */
		  NotFinished = 1;
		   *bp++='+';	
		   *bp++='"';
		   sFormatStr++;
		   while (*sFormatStr != '\'')
			*bp++=*sFormatStr++;
		   sFormatStr++;
		   *bp++='"';
		  while (*sFormatStr == ' ')
			sFormatStr++;	
		   if (*sFormatStr == ',')
		     {
			sFormatStr++;
			}
		   }
		 while (*sFormatStr==' ' )sFormatStr++;	
		   if (*sFormatStr =='/')
		    {
			NotFinished = 1;
			*bp++='+';
			*bp++='"';     
	       	      while (*(sFormatStr+1) == '/')
			{
			sFormatStr++;
			addstr("\\n");
			}
			addstr("\\n");
			sFormatStr++;
			*bp++='"';
			while (*sFormatStr == ' ')
			  sFormatStr++;
			if (*sFormatStr == ',')
			  sFormatStr++;
		     }
		while (*sFormatStr ==' ')
		 sFormatStr++;
		if (*sFormatStr >= '1' && *sFormatStr <= '9') 
			{  /* Deal with '?X' ---- WZG */
			int num = *sFormatStr - '0';
			sFormatStr++;
			NotFinished = 1; 
			*bp++='+';
			*bp++='"';
			while (*sFormatStr >='0' && *sFormatStr <= '9')
			 {
			 num=num*10+ *sFormatStr-'0';
			 sFormatStr++;
			 }
			if (*sFormatStr == 'X' || *sFormatStr == 'x')
			 {
			  for(;num>0;num--)
			   *bp++ = ' ';
			  sFormatStr++;
			 }	
			*bp++='"';
			while (*sFormatStr == ' ')
			  sFormatStr++;
			if (*sFormatStr == ',')
			 sFormatStr++;
			}
		     } /* end of while */
			   
		  }/*
		if (FormatSource !=NULL)
		  free(FormatSource);*/
		FormatSource = sFormatStr=NULL;
		addstr(");");
		break;
	case PRINT_STAT:/* added by Wu Zhigang */
		in_write_state=1;
		addstr("System.out.println(");
		cunp_llnd(pbf->entry.Template.ll_ptr1);
		in_write_state = 2;
		cunp_llnd(pbf->entry.Template.ll_ptr2);
		 
		if (*sFormatStr != '\0' && sFormatStr != NULL)
		 {/* deal with the left part of format statement */
		int NotFinished = 1;/* Whether current part is finished */
	      while (NotFinished) {
		NotFinished = 0; 		
		while (*sFormatStr == ' ')sFormatStr++;
		if (*sFormatStr == '\'')
		  {/* if string */
		  NotFinished = 1;
		   *bp++='+';	
		   *bp++='"';
		   sFormatStr++;
		   while (*sFormatStr != '\'')
			*bp++=*sFormatStr++;
		   sFormatStr++;
		   *bp++='"';
		  while (*sFormatStr == ' ')
			sFormatStr++;	
		   if (*sFormatStr == ',')
		     {
			sFormatStr++;
			}
		   }
		 while (*sFormatStr==' ' )sFormatStr++;	
		   if (*sFormatStr =='/')
		    {
			NotFinished = 1;
			*bp++='+';
			*bp++='"';     
	       	      while (*(sFormatStr+1) == '/')
			{
			sFormatStr++;
			addstr("\\n");
			}
			addstr("\\n");
			sFormatStr++;
			*bp++='"';
			while (*sFormatStr == ' ')
			  sFormatStr++;
			if (*sFormatStr == ',')
			  sFormatStr++;
		     }
		while (*sFormatStr ==' ')
		 sFormatStr++;
		if (*sFormatStr >='1' && *sFormatStr <= '9') 
			{  /* Deal with '?X' ---- WZG */
			int num = *sFormatStr - '0';
			NotFinished = 1; 
			sFormatStr++;
			*bp++='+';
			*bp++='"';
			while (*sFormatStr >='0' && *sFormatStr <='9')
			 {
			 num = num * 10 + *sFormatStr - '0';
			 sFormatStr++;
			 }
			if (*sFormatStr =='x' || *sFormatStr == 'X')
			 {
			 for(;num>0;num--)
			  *bp++ = ' ';	
			 sFormatStr++;
			 }
			*bp++='"';
			while (*sFormatStr == ' ')
			  sFormatStr++;
			if (*sFormatStr == ',')
			 sFormatStr++;
			}
		     } /* end of while */
			   
		  }/*
		if (FormatSource != NULL)
		  free(FormatSource);*/
		FormatSource = sFormatStr=NULL;
		addstr(");");
		in_write_state = 0;
		break;
	case OTHERIO_STAT:
	case COMM_STAT:
	case CONTROL_END:
		break;
	case ENUM_DECL :		/* New added for VPC */
	case CLASS_DECL:		/* New added for VPC */
	case UNION_DECL:		/* New added for VPC */
	case STRUCT_DECL:		/* New added for VPC */
	case COLLECTION_DECL:
	      {  PTR_BLOB blob ;
		 PTR_SYMB symb,symb1 ;
		 PTR_LLND llptr,llptr2;
		 int i;

		      llptr = pbf->entry.Template.ll_ptr1;
		      symb1 = find_declarator(llptr);
		      if (symb1) gen_descriptive_type(symb1);
		      switch (pbf->variant) {
		      case UNION_DECL: addstr("union ") ;
				       break;
		      case STRUCT_DECL:addstr("struct ") ;
				       break;
		      case ENUM_DECL  : addstr("enum ") ;
				       break;
		      case CLASS_DECL : addstr("class ") ;
				       break;
		      case COLLECTION_DECL : addstr("Collection ") ;
				       break;
		      }
		      if (symb=pbf->entry.Template.symbol) {
			    addstr(symb->ident);
			    *bp++ = ' ';
		      }
		     if (pbf->entry.Template.ll_ptr2) {
			addstr(" : ");
			for (llptr2 = pbf->entry.Template.ll_ptr2,i=0;llptr2; 
			     llptr2= llptr2->entry.Template.ll_ptr2,i++)
			      { if (i) addstr(" , ");
				addstr(llptr2->entry.Template.ll_ptr1->entry.Template.symbol->ident);
			      }
			  }
		       if (blob=pbf->entry.Template.bl_ptr1) 
			{   addstr(" {\n") ;
			    for ( ; blob ; blob = blob->next)
			       cunp_blck(blob->ref, tabs+2);
			    put_tabs(tabs);  addstr("} ");
			  } 
		       cunp_llnd(llptr);
                     /* The following is modified by Zheng Qiang to fit for Java */
                     switch (pbf->variant) {
                      case UNION_DECL:
                      case STRUCT_DECL:
                      case ENUM_DECL  :
                      case COLLECTION_DECL :
                       *bp++ = ';';
                      case CLASS_DECL :
                        break;
                       }
                       break;
		       /* *bp++ = ';';  Commented off by Zheng Qiang*/
	       }
	case DERIVED_CLASS_DECL:	/* Need More for VPC */
	case VAR_DECL:
		{  PTR_SYMB symb1 ;
		   PTR_LLND llptr;
		    
                   in_var_decl_stmt = 1;
		   /* A static variable indicate where the unparse process in , 
			above line is added by Zheng Qiang*/
		   llptr = pbf->entry.Template.ll_ptr1;
		   symb1 = find_declarator(llptr);
		   if (symb1)
			   gen_simple_type(symb1->type, pbf, tabs) ;
		   cunp_llnd(llptr);
		   if (pbf->control_parent->variant != ENUM_DECL)
			   addstr(" ;");
		   in_var_decl_stmt = 0; /*Added by Zheng Qiang */
		   in_var_decl_deleted = 0; /* added by Wu Zhigang */
		}
		   break;
	case EXPR_STMT_NODE:		/* New added for VPC */
		   cunp_llnd(pbf->entry.Template.ll_ptr1);
		   addstr(" ;");
		   break ;
	case DO_WHILE_NODE:		/* New added for VPC */
					/* Need study	     */
	case SWITCH_NODE :		/* New added for VPC */
		   addstr("switch (");
		   cunp_llnd(pbf->entry.Template.ll_ptr1);
		   *bp++ = ')';
		   break ;
	case CASE_NODE :		/* New added for VPC */
		   addstr("case ");
		   cunp_llnd(pbf->entry.Template.ll_ptr1);
		   addstr(" : ") ;
		   break ;
	case DEFAULT_NODE:		/* New added for VPC */
		   addstr("default :") ;
		   break;
	case BASIC_BLOCK :
		   break ;
	case BREAK_NODE  :		/* New added for VPC */
		   addstr("break;");
		   break;
	case CONTINUE_NODE:		/* New added for VPC */
		   addstr("continue;");
		   break; /* this statement is added by Zheng Qiang */
	case RETURN_NODE  :		/* New added for VPC */
                /* Following is added by Zheng Qiang to fit for Java*/

                if(pbf->control_parent->variant = FUNC_HEDR) {
		char	 * index="   ";
                int      para_nu; /* The number of parameters */
                PTR_BFND parent;
                PTR_SYMB sp;

                parent = pbf->control_parent;
                para_nu = parent->entry.function.func_symb->entry.func_decl.num_input;
                for ( sp = parent->entry.function.func_symb->entry.func_decl.in_list,i = 1;
                        i <= para_nu;
                        sp = sp->entry.var_decl.next_in, i++) {
                        /* addstr(sp->ident); */
						sprintf(index,"%d",i);
						addstr("argu");
						addstr(index);
                        addstr("_cv = "); 
                        addstr(sp->ident);
                        addstr(";\n");
                        put_tabs(tabs);
                        }
                /* The end of what Zheng Qiang added */

                addstr("return");
		in_return_state = 1;
                if (pbf->entry.Template.ll_ptr1) {
                        addstr("(");
                        cunp_llnd(pbf->entry.Template.ll_ptr1);
                        addstr(")");
                }
		addstr(";");
		in_return_state = 0;
                }
		break;
	case ASM_NODE	  :		/* New added for VPC */
		break;			/* Need More	     */
	case SPAWN_NODE :		/* New added for VPC */
		addstr("spawn");
		cunp_llnd(pbf->entry.Template.ll_ptr1);
		addstr(" ; ");
		break;
	case PARFOR_NODE  :		/* New added for VPC */
		addstr("parfor (");
		cunp_llnd(pbf->entry.Template.ll_ptr1);
		*bp++ = ';';
		cunp_llnd(pbf->entry.Template.ll_ptr2);
		*bp++ = ';';
		cunp_llnd(pbf->entry.Template.ll_ptr3);
		addstr(") ") ;
		break;
	case FUTURE_STMT:
	       addstr("future ");
	       cunp_llnd(pbf->entry.Template.ll_ptr1);
	       addstr(" (");
	       cunp_llnd(pbf->entry.Template.ll_ptr2);
	       addstr(")");
	       break;
	case PAR_NODE  :		/* New added for VPC */
		addstr("par ") ;
		break;
	case ENDDO_STMT :
		break;
	default:
		printf(" unknown biffnode = %d\n", pbf->variant);
		exit(0);
		break;		/* don't know what to do at this point */
	}
	if (pbf->variant != FORMAT_STAT)/* added by Wu Zhigang for FORMAT */
	  *bp++ = '\n';

        addstr(args_buf);
        clean(args_buf); 
        /* Added by Zheng Qiang to fit for Java */
}


/************************************************************************
 *									*
 *		     generate simple declaration			*
 *									*
 ************************************************************************/
static void
gen_simple_type(q_type, dum_pbf, tabs)
	PTR_TYPE q_type ;
	PTR_BFND dum_pbf ;
	int tabs;
{
   PTR_TYPE q,q3 ;
   PTR_SYMB s ,symb;
   PTR_BLOB blob ;
   PTR_BFND pbf;
   int i;

	for (q = q_type ; q ; ) {
		switch (q->variant) {
		case T_COMPLEX : /* added by Wu Zhigang */
		case T_DCOMPLEX  :
			addstr("Complex ");
			q = (PTR_TYPE)NULL;
			break;
		case T_STRING :/* Is string type ---added by Wu Zhigang for Java*/
			addstr("String ");
			q = (PTR_TYPE)NULL;
			break;
		case T_KIND : /* That represent String type---added by Wu Zhigang for Java */
		case T_REFERENCE:
		case T_POINTER	:
 		case T_FUNCTION :
		case T_ARRAY	:
			q = q->entry.Template.base_type;/* get var's base type*/
			break ;
		case T_DESCRIPT :
			for (i=1; i< MAX_BIT; i *= 2)
				addstr1(q->entry.descriptive.long_short_flag & i);
			q = q->entry.descriptive.base_type ;
			break ;
		case DEFAULT :	q = (PTR_TYPE ) NULL ;
			break ;
		case T_DERIVED_COLLECTION :
		      symb = q->entry.col_decl.collection_name;
		      q3 = q->entry.col_decl.base_type;
		      addstr(symb->ident);
		      if (q3) {
			addstr("<");
			gen_simple_type(q3,dum_pbf,tabs);
			addstr(">");
		      }
		      addstr(" ");
		     q= (PTR_TYPE) NULL ;
		    break;
		case T_DERIVED_TYPE :
			s = q->entry.derived_type.symbol ;
			switch (s->variant) {
			case STRUCT_NAME:	addstr("struct "); break;
			case ENUM_NAME: 	addstr("enum ");   break;
			case UNION_NAME:	addstr("union ");  break;
			case CLASS_NAME:	break;
			case COLLECTION_NAME:	 break;
			case TYPE_NAME:
			default:
				break ;
			}
			addstr(s->ident);
			*bp++ = ' ';
			if (s->variant==COLLECTION_NAME) {
			  if (q3=s->type->entry.derived_class.base_type) {
			      addstr("<");
			      gen_simple_type(q3,dum_pbf,tabs);
			      addstr(">");
			    }
			}
			q = (PTR_TYPE) NULL ;
			break ;

		case T_INT     :
			addstr("int ");
			q= (PTR_TYPE) NULL ;
			break;
		case T_CHAR    :
			addstr("char ");
			q= (PTR_TYPE) NULL ;
			break;
		case T_VOID    :
			addstr("void ");
			q= (PTR_TYPE) NULL ;
			break;
		case T_DOUBLE  :
			addstr("double ");
			q= (PTR_TYPE) NULL ;
			break;
		case T_FLOAT   :
			addstr("float ");
			q= (PTR_TYPE) NULL ;
			break;

		case T_UNION   :
		case T_STRUCT  :
		case T_ENUM    :
		case T_CLASS   :
			switch (q->variant) {
			case T_UNION   : addstr("union ") ;
				break;
			case T_STRUCT  : addstr("struct ") ;
				break;
			case T_ENUM    : addstr("enum ") ;
				break;
			case T_CLASS   : addstr("class ") ;
				break;
			case T_COLLECTION: addstr("Collection ") ;
				       break;
			}

			if (symb=q->entry.derived_class.original_class->entry.Template.symbol) {
				addstr(symb->ident);
				*bp++ = ' ';
			}	    

			q = (PTR_TYPE) NULL ;
			break;
		case T_COLLECTION:
		      if (symb=q->entry.derived_class.original_class->entry.Template.symbol)
			{   addstr(symb->ident);
			    if (q3=q->entry.derived_class.base_type) {
			      addstr("<");
			      gen_simple_type(q3,dum_pbf,tabs);
			      addstr(">");
			    }
			    addstr(" ");
			  }
		      q= (PTR_TYPE) NULL ;
		      break;
	    /* not in leejenq's version
		case T_DERIVED_CLASS:
		   {	PTR_BFND pbf ;

			pbf = q->entry.derived_class.original_class ;
			addstr("class");
			if (symb=pbf->entry.Template.symbol)
				addstr(symb->ident);
			addstr(" : ");
			cunp_llnd(pbf->entry.Template.ll_ptr2);
			if (blob=pbf->entry.Template.bl_ptr1) {
				addstr(" {") ;
				for ( ; blob ; blob = blob->next)
					cunp_bfnd(tabs,blob->ref);
				put_tabs(tabs);  *bp++ = '}';
			}
			break ;
		}
	     */
		default :
			break;
		}
	}
}


static int
cprecedence(op)
	int op ;
{   
    switch (op)  {
	case NEW_OP:	   
	case DELETE_OP:
			    return(2);
	case EQ_OP	:   return(7);
	case LT_OP	:   return(6);
	case GT_OP	:   return(6);
	case NOTEQL_OP	:   return(7);
	case LTEQL_OP	:   return(6);
	case GTEQL_OP	:   return(6);
	case ADD_OP	:   return(4);
	case OR_OP	:   return(12);
	case MULT_OP	:   return(3);
	case DIV_OP	:   return(3);
	case AND_OP	:   return(11);
	case XOR_OP	:   return(9);

	case LE_OP	:   return(6);	/* duplicated */
	case GE_OP	:   return(6);	/* duplicated */
	case NE_OP	:   return(7);	/* duplicated */
	case UNARY_ADD_OP:  return(2);	/* unary operation */

	case SUBT_OP	:   return(11); /* binary operator */
	case MINUS_OP	:   return(2);	/* unary operator */
	case NOT_OP	:   return(2);

	case PLUS_ASSGN_OP:
	case MINUS_ASSGN_OP:
	case AND_ASSGN_OP:
	case  IOR_ASSGN_OP:
	case  MULT_ASSGN_OP:
	case  DIV_ASSGN_OP:
	case MOD_ASSGN_OP:
	case  XOR_ASSGN_OP:
	case  LSHIFT_ASSGN_OP:
	case  RSHIFT_ASSGN_OP :

	case ARITH_ASSGN_OP:
	case ASSGN_OP	:   return(14);
	case DEREF_OP	:   return(2);
	case POINTST_OP :   return(1);
	case RECORD_REF :   return(1);
	case BITAND_OP	:   return(10);
	case BITOR_OP	:   return(10);
	case LSHIFT_OP	:   return(5);
	case RSHIFT_OP	:   return(5);
	case MOD_OP :	return(3);	  /* New added for VPC */
	case ADDRESS_OP:    return(2);
	case SIZE_OP   :    return(2);
	case PLUSPLUS_OP:
	case MINUSMINUS_OP: return(2);
	case EXPR_LIST	:    return(15);
	default 	:   return(0);
	}
}


int
mapping(op)
int op ;
{
    switch (op)  {
	case EQ_OP	:   return(20);
	case LT_OP	:   return(16);
	case GT_OP	:   return(17);
	case NOTEQL_OP	:   return(21);
	case LTEQL_OP	:   return(18);
	case GTEQL_OP	:   return(19);
	case ADD_OP	:   return(12);
	case OR_OP	:   return(26);
	case MULT_OP	:   return(9);
	case DIV_OP	:   return(10);
	case AND_OP	:   return(25);
	case XOR_OP	:   return(23);

	case LE_OP	:   return(18); /* duplicated */
	case GE_OP	:   return(19); /* duplicated */
	case NE_OP	:   return(21); /* duplicated */
	case SUB_OP	:   return(5); /* unary operator */
	case MINUS_OP	:   return(5); /* unary operator */
	case SUBT_OP   :   return(5); /* binary operator */
	case NOT_OP	:   return(1);

	case PLUS_ASSGN_OP: return(28);
	case MINUS_ASSGN_OP:return(29);
	case AND_ASSGN_OP:  return(30);
	case  IOR_ASSGN_OP: return(31);
	case  MULT_ASSGN_OP:return(32);
	case  DIV_ASSGN_OP: return(33);
	case MOD_ASSGN_OP:  return(34);
	case  XOR_ASSGN_OP: return(35);
	case  LSHIFT_ASSGN_OP:return(36);
	case  RSHIFT_ASSGN_OP :return(37);
	case ASSGN_OP	:   return(27);

	case DEREF_OP	:   return(6);
	case POINTST_OP :   return(0);
	case BITAND_OP	:   return(22);
	case BITOR_OP	:   return(24);
	case LSHIFT_OP	:   return(15);
	case RSHIFT_OP	:   return(14);
	case MINUSMINUS_OP: return(4);		   /* New added for VPC */
	case PLUSPLUS_OP  : return(3);		   /* New added for VPC */
	case UNARY_ADD_OP : return(12); 	   /* New added for VPC */
	case BIT_COMPLEMENT_OP :return(2);	   /* New added for VPC */
	case MOD_OP :	return(11);	   /* New added for VPC */
	case SIZE_OP :	     return(8); 	   /* New added for VPC */
	case ADDRESS_OP:     return(7);
	default 	:   sprintf(buffera, "bad case 1");
			    return(0);
	}
}


static void
gen_op(value)
	int value;
{
    switch (value) {
    case ((int) PLUS_EXPR) : addstr("+= ");
	break;
    case ((int) MINUS_EXPR): addstr("-= ");
	break;
    case ((int) BIT_AND_EXPR):addstr("&= ");
	break;
    case ((int) BIT_IOR_EXPR):addstr("|= ");
	break;
    case ((int) MULT_EXPR):  addstr("*= ");
	break;
    case ((int) TRUNC_DIV_EXPR): addstr("/= ");
	break;
    case ((int) TRUNC_MOD_EXPR): addstr("%= ");
	break;
    case ((int) BIT_XOR_EXPR): addstr("^= ");
	break;
    case ((int) LSHIFT_EXPR): addstr("<<= ");
	break;
    case ((int) RSHIFT_EXPR): addstr(">>= ");
	break;
	default : addstr("= ");
    }
}

static char left_mod[2000];
static void
gen_simple_type_2(q_type, dum_pbf, tabs)
	PTR_TYPE q_type;
	PTR_BFND dum_pbf;
	int tabs;
{
   PTR_BFND pbf;
   PTR_TYPE q ;
   PTR_SYMB s ,symb;
   PTR_BLOB blob ;
   PTR_LLND r1;
   char *old_bp;
   int level ;
   int i;
char * bp_save;

   left_mod[0] = '\0';
   level= 0 ;
   clean(temp_buf);
    for (q = q_type ; q ; )
    {
     switch (q->variant) {
     case T_POINTER  :
	put_left("*",temp_buf);
	level = 1;
	q = q->entry.Template.base_type ;
	break;
     case T_REFERENCE:
	put_left("&",temp_buf);
	level = 1;
	q = q->entry.Template.base_type ;
	break;
     case T_FUNCTION :
	put_left("(",temp_buf);
	put_right(")",temp_buf);
	put_right("()",temp_buf);
	q = q->entry.Template.base_type ;
	break;
     case T_ARRAY    :
	if (level >0) {
	    put_left("(",temp_buf);
	    put_right(")",temp_buf);
	  }
	clean(temp1_buf);
	bp_save = bp;  /* Backup before switching buffer */
	put_left(buffer,temp1_buf);  /* Backup before switching buffer */
	clean(buffer);
	bp = &(buffer[0]);
	for (r1=q->entry.ar_decl.ranges;r1; r1= r1->entry.Template.ll_ptr2)
	  {
	    addstr("[");
	    cunp_llnd(r1->entry.Template.ll_ptr1);
	    addstr("]");
	  }
	put_right(buffer,temp_buf);
	clean(buffer);
	bp = bp_save;
	put_left(temp1_buf,buffer);
	q = q->entry.Template.base_type ;
	break ;
     case T_DESCRIPT :
	clean(temp1_buf);
	bp_save = bp;                /* Backup before switching buffer */
	put_left(buffer,temp1_buf);  /* Backup before switching buffer */
	clean(buffer);  
	bp = &(buffer[0]);
	for (i=1; i< MAX_BIT; i= i*2)
	  addstr1(q->entry.descriptive.long_short_flag & i);
	put_right(buffer, left_mod);
	clean(buffer); 
	bp = bp_save;
	put_left(temp1_buf,buffer);
	q = q->entry.descriptive.base_type ; 
	break ;
    case DEFAULT : 
	put_left("int ",temp_buf);
	q = (PTR_TYPE ) NULL ;
	break ;
    case T_DERIVED_TYPE :
	clean(temp1_buf);
	bp_save = bp;                /* Backup before switching buffer */
	put_left(buffer,temp1_buf);  /* Backup before switching buffer */
	clean(buffer);
	bp = &(buffer[0]);
	s = q->entry.derived_type.symbol ;
	switch (s->variant) {
	case STRUCT_NAME: addstr("struct "); break;
	case ENUM_NAME:   addstr("enum ");   break;
	case UNION_NAME:  addstr("union ");  break;
	case CLASS_NAME:  addstr("class ");  break;
	case COLLECTION_NAME:  addstr("Collection ");  break;
	case TYPE_NAME:
	default:
	  break ;
	}
	addstr(s->ident);
	addstr(" ");
	put_left(buffer,temp_buf);
	clean(buffer);
	bp = bp_save;
	put_left(temp1_buf,buffer);
	q = (PTR_TYPE) NULL ;
	break ;
   case T_INT	  :
       put_left("int ",temp_buf);
       q= (PTR_TYPE) NULL ;
       break;
   case T_CHAR	  :
       put_left("char ",temp_buf);
       q= (PTR_TYPE) NULL ;
       break;
   case T_VOID	  :
	put_left("void ",temp_buf);
	q= (PTR_TYPE) NULL ;
	break;
   case T_DOUBLE  :
	put_left("double ",temp_buf);
	q= (PTR_TYPE) NULL ;
	break;
   case T_FLOAT   :
	put_left("float ",temp_buf);
	q= (PTR_TYPE) NULL ;
	break;
   case T_UNION   :
   case T_STRUCT  :
   case T_ENUM	  :
   case T_CLASS   :
   case T_COLLECTION:
   case T_DERIVED_CLASS:
     clean(temp1_buf);
     bp_save = bp;                /* Backup before switching buffer */
     put_left(buffer,temp1_buf);  /* Backup before switching buffer */
     clean(buffer);
     bp = &(buffer[0]);
     switch (q->variant) {
     case T_UNION   : addstr("union ") ;
       break;
     case T_STRUCT  : addstr("struct ") ;
       break;
     case T_ENUM    : addstr("enum ") ;
       break;
     case T_DERIVED_CLASS:
     case T_CLASS   : addstr("class ") ;
       break;
     case T_COLLECTION	: addstr("Collection ") ;
       break;
     }
     if (symb=q->entry.derived_class.original_class->entry.Template.symbol)
       {   addstr(symb->ident);
	   addstr(" ");
	 }	   
     pbf = q->entry.derived_class.original_class ;
     if (pbf->entry.Template.ll_ptr2) {
       addstr(" : ");
       cunp_llnd(pbf->entry.Template.ll_ptr2);
     }
     if (blob= q->entry.derived_class.original_class->entry.Template.bl_ptr1)
       {   addstr(" {\n") ;
	   for ( ; blob ; blob = blob->next)
	     { 
	       cdrtext(blob->ref,tabs,0,100);  
	       addstr("\n");
	     }
	   put_tabs(tabs);  addstr("} ");
	 }
     put_left(buffer,temp_buf);
     clean(buffer);
     bp = bp_save;
     put_left(temp1_buf,buffer);
     q = (PTR_TYPE) NULL ;
     break;
  default :	 sprintf(buffera,"unexpected type");
      }
   }
   put_left(left_mod, temp_buf);
   addstr(temp_buf);
}

static
void cunp_llnd(pllnd)
PTR_LLND	pllnd;
{
  PTR_LLND pll2;
  char ch;  
	if (pllnd == NULL)
		 return;

	switch (pllnd->variant) {
	case INT_VAL	:
	    { char sb[64];
		
	      if (in_write_state )
		addstr("String.valueOf(");
	      sprintf(sb, "%d", pllnd->entry.ival);
	      addstr(sb);
	     if (in_write_state )
		addstr(")+' '");
	    }
	      break;
	case STMT_STR	: break ;
	case FLOAT_VAL	:
		if (in_write_state )
                   addstr("String.valueOf(");
		addstr("(float)");
		addstr(pllnd->entry.string_val);
		if (in_write_state )
                   addstr(")+' '");
                break;
	case DOUBLE_VAL :
		if (in_write_state )
                   addstr("String.valueOf(");
		addstr(pllnd->entry.string_val);
		if (in_write_state )
                   addstr(")+' '");
		break;
	case STRING_VAL :/* added by Wu Zhigang for String Assignment */
		sprintf(buffera, "%s", pllnd->entry.string_val);
		if (*buffera == '\''){
		   *buffera = '"';
		   *(buffera+strlen(buffera)-1) = '"';
		   addstr(buffera);
		  }
		else {
		  *bp++ = '"';
		  addstr(buffera);
		  *bp++ = '"';
		  }
		if (in_write_state)
			addstr("+' '");
		break;
	case BOOL_VAL	:
		break;
	case CHAR_VAL	:
		ch = pllnd->entry.cval;
		switch (ch) {
		case  '\t': addstr("\'\\");  addstr("t\'"); return;
		case '\n':  addstr("\'\\"); addstr("n\'"); return;
		case '\b':  addstr("\'\\"); addstr("b\'"); return;
		case '\f':  addstr("\'\\"); addstr("f\'"); return;
		case '\r':  addstr("\'\\"); addstr("r\'"); return;
		case '\0':  addstr("\'\\"); addstr("0\'"); return;
		case '\\':  addstr("\'\\"); addstr("\\"); addstr("\'"); return;
		case '\'':  addstr("\'\\"); addstr("\'\'"); return;
		default: break;
		}
		sprintf(buffera, "\'%c\'",pllnd->entry.cval);
		addstr(buffera);
		break;
	case THIS_NODE:
	       addstr("this");
	       break;
	case VAR_REF	:/* new added by Wu Zhigang for Java */
	        { 
                  PTR_SYMB symbtemp;
                  int if_same_name=0;
                  char * temp_name=NULL;
		if (in_read_state)
		  {
		  addstr("try { \n	"); /* add IOException dealing */
		  if (*bp == ',')
			 bp--;  /* delete last ',' */
		  }
		if (in_equi_state) /* if equivalence statement */
		  {
		   /* static int FirstEquiVar = 1;*/
		   static char sEquiVarName[15];
		   if (FirstEquiVar) {
			strcpy(sEquiVarName,pllnd->entry.Template.symbol->ident);
			FirstEquiVar = 0;
			}
		     else
			{
			free(pllnd->entry.Template.symbol->ident);
			pllnd->entry.Template.symbol->ident = malloc(sizeof(char)*(strlen(sEquiVarName)+1));
			strcpy(pllnd->entry.Template.symbol->ident,sEquiVarName);
			}
		   } /* end of equivalence ;*/
		 else
		  {	
		if (!in_read_state && !in_common_state )
		   {
		   if (in_var_decl_stmt && strchr(pllnd->entry.Template.symbol->ident,'.'))
		    {
		     while (*(bp-1) == ',' || *(bp-1) == ' ')
			bp--;
		     if (!in_var_decl_deleted)	
			{
			static int count = 0;
			in_var_decl_deleted = 1;
			addstr("  ReplaceMentVar");
			*bp++ = (char)(count++ + '0');
		      }						
		     }
		    else	
		   /* output variable name */   
/*
		   {
                    temp_name=pllnd->entry.Template.symbol->ident;  
                    for(symbtemp=pllnd->entry.Template.symbol->next_symb;symbtemp;symbtemp= symbtemp->next_symb)
                      {
                        if(strcmp(temp_name,symbtemp->ident))
                           if_same_name=1;
                       }
                     if(if_same_name)break;
*/     
  /* added by WZG for bugs on operation about Complex type variables */
		   if (in_var_decl_stmt) /* variable declarement */
			addstr(pllnd->entry.Template.symbol->ident);
		  else 	
		   switch (pllnd->entry.Template.symbol->type->variant)
		    {
		     case T_COMPLEX:
		     case T_DCOMPLEX :
		       switch ( *(bp-1))
			{
			case '=' :
				addstr("((Complex)");
				addstr(pllnd->entry.Template.symbol->ident);
				addstr(".clone())");
				break;
			case '+' :
			    	bp--;/* delete '+' */
                        	addstr(".add(");
				addstr(pllnd->entry.Template.symbol->ident);
 	                        addstr(")");
        	                break;

			case '-' :
				bp--;/* delete '-' */
                        	addstr(".minus(");
				addstr(pllnd->entry.Template.symbol->ident);
                       		addstr(")");
                    	        break;
			case '*' :
			     { /* define a block */
				char buf[200];
				int index = 0,len = 0;
				bp--;/* delete '*' */
 	                        /* bp--; delete the last ')' */
				while (*(bp-len) != '(')
				  len++;
				for(len--;len;len--)
				  buf[index++] = *(bp-len);
				buf[index] = '\0';
				bp-=index;
				addstr("(new Complex(");
				addstr(buf);
        	                addstr(").mult(");
				addstr(pllnd->entry.Template.symbol->ident);
                        	addstr("))");
			/* the last ')' deleted before is added hrer */
    	                        break;
			      }	
			case '/' :
				{ /* define a block */
                                char buf[200];
                                int index = 0,len = 0;
                                bp--;/* delete '*' */
                                while (*(bp-len) != '(')
                                  len++;
                                for(len--;len;len--)
                                  buf[index++] = *(bp-len);
                                buf[index] = '\0';
                                bp-=index;
                                addstr("(new Complex(");
                                addstr(buf);

                	        addstr(").div(");
				addstr(pllnd->entry.Template.symbol->ident);
                        	addstr("))");/* the last ')' is added here */
                        	break;
				}
			default :
				/*addstr(")");*/
				addstr(pllnd->entry.Template.symbol->ident);
				break;	
			}
			break;
		      case T_INT:
		      case T_FLOAT:
		      case T_DOUBLE:
			if (in_write_state)
			  addstr("String.valueOf(");
		        addstr(pllnd->entry.Template.symbol->ident);
		  	if (in_write_state)
			   addstr(")+' '");
			break;
		
		      default :/* not complex type */
		   	addstr(pllnd->entry.Template.symbol->ident);
			break;
		      }
		   } /* end of variable name output */	
		 }
		if (in_read_state || in_common_state)/* added by Wu Zhigang */
		  {
		   PTR_TYPE atype = pllnd->entry.Template.symbol->type;
		   char newName[30],oldName[20];
		   strcpy(newName,CommonName[current_common]);
		   strcat(newName,".");
		   strcpy(oldName,pllnd->entry.Template.symbol->ident);
		   if (in_read_state)
			addstr(pllnd->entry.Template.symbol->ident);	
		   if (in_common_state) /* 1 or 2 */
		    {
		     if (in_common_state == 1)
		     {
		     CommonName_var[current_common][Common_Offset[current_common]] = malloc(sizeof(char)*NAMELEN);
		     nFreeFlag[current_common]++;
			strcpy(CommonName_var[current_common][Common_Offset[current_common]++],pllnd->entry.Template.symbol->ident);		
		     strcat(newName,pllnd->entry.Template.symbol->ident);
		     }
		    else
			strcat(newName,CommonName_var[current_common][Common_Offset[current_common]++]);
		    free(pllnd->entry.Template.symbol->ident);
		    pllnd->entry.Template.symbol->ident = malloc(sizeof(char) * (strlen(newName)+1));
		   strcpy(pllnd->entry.Template.symbol->ident,newName);
		  } /* end of if */  		
		  while (atype )
		   switch (atype->variant)
		    {
		     case T_INT :
		      if (in_read_state)		
		       addstr(" = InputData.readInt();\n");
		      else
			if (in_common_state == 1 && bCommonNotInitiated)
			  /* addstr("public static int ");*/
			  strcat(NamedCommon[current_common],"public static int ");
		      atype = (PTR_TYPE)NULL;	
			break;
		     case T_FLOAT :
		      if (in_read_state)	
		       addstr(" = InputData.readFloat();\n");
		      else
			if (in_common_state == 1  && bCommonNotInitiated)
			 strcat(NamedCommon[current_common],"public static float  ");
			atype = (PTR_TYPE)NULL;
		      break;
		     case T_DOUBLE :
			if (in_read_state)
			 addstr(" = InputData.readDouble();\n");
			else
			 if (in_common_state == 1 && bCommonNotInitiated)
			  strcat(NamedCommon[current_common],"public static double  ");	 
			atype = (PTR_TYPE)NULL;
			break;
		     case T_CHAR :
			if (in_read_state)
			 addstr(" = InputData.readChar();\n");
			else
			 if (in_common_state == 1 && bCommonNotInitiated)
			   strcat(NamedCommon[current_common],"public static char ");					
			atype = (PTR_TYPE)NULL;
			break;
		     case T_STRING :
			if (in_read_state  )
			 addstr(" = InputData.readString();\n");
			else
			 if (in_common_state == 1 && bCommonNotInitiated)
			  strcat(NamedCommon[current_common],"public static String ");

			atype = (PTR_TYPE)NULL;
			break;
		     case T_BOOL :
			if (in_read_state)
			 addstr(" = InputData.readBool();\n");
			else
			  if (in_common_state == 1 && bCommonNotInitiated)
				strcat(NamedCommon[current_common],"public static boolean ");				
			atype = (PTR_TYPE)NULL;
			break;
		     case T_COMPLEX :
		     case T_DCOMPLEX :
			if (in_read_state)
			 addstr(" = InputData.readComplex();\n");
			else
			 if (in_common_state == 1 && bCommonNotInitiated)
			  strcat(NamedCommon[current_common],"public static Complex ");
			 atype = (PTR_TYPE)NULL;
			break;
		     case T_KIND : /* string type ,etc. */
			atype = atype->entry.Template.base_type;
			break;
					
		   } /*end of switch */
		if (in_read_state) 
		  addstr("	}catch (IOException e) {  };\n"); /* add IOException catch statement */
		 if (in_common_state == 1 && bCommonNotInitiated)
		   {
		strcat(NamedCommon[current_common],oldName);
		strcat(NamedCommon[current_common],";\n");
		   }	
		 } /* end of if block */						
		}
	       } /* end of in_equi_state --- if */	
		break;
	case CONST_REF  :/* added by Wu Zhigang for String Const Decl */
		{
		PTR_LLND pConstVal;
		addstr(pllnd->entry.Template.symbol->ident);
		addstr("=");
		if ((pConstVal = pllnd->entry.Template.symbol->entry.const_value) != NULL){
		cunp_llnd(pConstVal);
		addstr(";");
		   }
		break;}
	case SUB_STRING :/* added by WU Zhigang for subString */
		in_subString_val = 1;
		
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		cunp_llnd(pllnd->entry.Template.ll_ptr2);
		break;
	case RANGE_OP :/* added by Wu Zhigang for subString's range */
		addstr(".substring((");
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		addstr("-1),(");
		cunp_llnd(pllnd->entry.Template.ll_ptr2);
		addstr("-1))");
		in_subString_val = 0;
		break;
	case CONCAT_OP  : /* added by Wu Zhigang for String Concat */
		in_StringConcat++;/* set Concat flag */
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		addstr(" + ");
		/*in_StringConcat = 1;* in above call,it may be changed */
		cunp_llnd(pllnd->entry.Template.ll_ptr2);
		in_StringConcat--;/* Restore concat flag */
		break;
	case COMPLEX_VAL :/* added by Wu Zhigang */
		if (in_return_state  == 1)
		 {
		 addstr("((new Complex(");
		 in_return_state = 2;
		 cunp_llnd(pllnd->entry.Template.ll_ptr1);
		 addstr(",");
		 cunp_llnd(pllnd->entry.Template.ll_ptr2);
		 addstr(")))");
		 break;
		 }
		else
		switch(*(bp-1)) {
		  case '=' :
			addstr("((new Complex(");
		        cunp_llnd(pllnd->entry.Template.ll_ptr1);
			addstr(",");
			cunp_llnd(pllnd->entry.Template.ll_ptr2);
			addstr(")))");		
			break;
		  case '+' :
			bp--;/* delete '+' */
			addstr(".add((new Complex(");
			cunp_llnd(pllnd->entry.Template.ll_ptr1);
			addstr(",");
			cunp_llnd(pllnd->entry.Template.ll_ptr2);
			addstr(")))");
			break;
		  case '-' :
			bp--;/* delete '-' */
			addstr(".minus((new Complex(");
			cunp_llnd(pllnd->entry.Template.ll_ptr1);
			addstr(",");
			cunp_llnd(pllnd->entry.Template.ll_ptr2);
			addstr(")))");
			break;
		  case '*' :
			bp--;/* delete '*' */
			bp--;/* delete the last ')' */
			addstr(".mult(");
			cunp_llnd(pllnd->entry.Template.ll_ptr1);
			addstr(",");
			cunp_llnd(pllnd->entry.Template.ll_ptr2);
			addstr("))");/* the last ')' deleted before is added hree */
			break;
		  case '/' :
			bp--;/* delete '/' */
			bp--;/* delete the last ')' */
			addstr(".div(");
			cunp_llnd(pllnd->entry.Template.ll_ptr1);
			addstr(",");
			cunp_llnd(pllnd->entry.Template.ll_ptr2);
			addstr("))");/* the last ')' is added here */
			break;
		   }
			
	case ENUM_REF	:

		break;
	case RECORD_REF:		    
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		*bp++ = '.';
		cunp_llnd(pllnd->entry.Template.ll_ptr2);
		break ;
	case ARRAY_OP :
		*bp++ = '(';
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		for (pll2 = pllnd->entry.Template.ll_ptr2;pll2; pll2= pll2->entry.Template.ll_ptr2) {
			*bp++ = '[';
			cunp_llnd(pll2->entry.Template.ll_ptr1);
			*bp++ = ']';
		}
		*bp++ = ')';
		break;

	case ARRAY_REF	:
		{
		int array_dimension=0;
		int tempi=0;
		int tempj=0;
		if (in_read_state)/* add IOException */
		  addstr(" try {\n	");
		addstr(pllnd->entry.array_ref.symbol->ident);
                /*array_dimension = pllnd->type->entry.ar_decl.num_dimensions;  */
		
                if(in_var_decl_stmt) 
                {
                        addstr("[]");
                        addstr(" = new ");
                        gen_simple_type(pllnd->entry.array_ref.symbol->type);

	                *bp++ = '[';
	          for (pll2 = pllnd->entry.Template.ll_ptr1;pll2; pll2= pll2->entry.Template.ll_ptr2) 
                    {
                       
                        *bp++ = '(';
                        cunp_llnd(pll2->entry.Template.ll_ptr1->entry.Template.ll_ptr1->entry.Template.ll_ptr2);
                        if (pll2->entry.Template.ll_ptr1->entry.Template.ll_ptr1->entry.Template.ll_ptr1 != NULL)
		      {
			addstr("-");
			addstr("("); 
			cunp_llnd(pll2->entry.Template.ll_ptr1->entry.Template.ll_ptr1->entry.Template.ll_ptr1);
			addstr(")"); 
                    
			addstr("+1"); 
                       }
			addstr(")");
			if (pll2->entry.Template.ll_ptr2 != NULL)
			addstr("*");
	            }
	                addstr("]");
                 } 
		else {
		 
            int i = 0;
			PTR_LLND low_decl_point[100];
			PTR_LLND high_decl_point[100];
			PTR_LLND array_index[100];
			PTR_LLND pll_range = pllnd->type->entry.ar_decl.ranges;
			array_dimension = pllnd->type->entry.ar_decl.num_dimensions;
                        for(pll2 = pll_range; pll2 ; pll2 = pll2->entry.Template.ll_ptr2)
                     {   
                        if(pll2->entry.Template.ll_ptr1->entry.Template.ll_ptr1->entry.Template.ll_ptr1)
                            low_decl_point[i] = pll2->entry.Template.ll_ptr1->entry.Template.ll_ptr1->entry.Template.ll_ptr1;
                            else low_decl_point[i] = NULL;
                         high_decl_point[i] = pll2->entry.Template.ll_ptr1->entry.Template.ll_ptr1->entry.Template.ll_ptr2;
                         i++;
                     } 
                         i = 0;
                         for(pll2 = pllnd->entry.Template.ll_ptr1;pll2; pll2= pll2->entry.Template.ll_ptr2)
                     {
                         array_index[i] = pll2->entry.Template.ll_ptr1;
                         i ++;
                     }
                         addstr("[");
                         for(tempi = array_dimension-1;tempi >= 0 ; tempi-- )
                     {
                               for(tempj = 0; tempj<tempi ; tempj++)
                             {
                               addstr("(");
                               addstr("(");
                               cunp_llnd(high_decl_point[tempj]); 
                               addstr(")");
                               addstr("-");
                               if(low_decl_point[tempj]==NULL)
                                  addstr("1");
                               else {
                                     addstr("(");
                                     cunp_llnd(low_decl_point[tempj]); 
                                     addstr(")");
                                     }
                               addstr("+1");
                               addstr(")");
                               addstr("*");
                             }
                               addstr("(");
                               addstr("(");
                               cunp_llnd(array_index[tempj]); 
                               addstr(")");
                               addstr("-");   
                               if(low_decl_point[tempj] == NULL)
                                   addstr("1");
                               else 
                                    {
                                       addstr("(");
                                       cunp_llnd(low_decl_point[tempj]);
                                       addstr(")");
                                     }
                               addstr(")");
                               if(tempi!=0)
                               addstr("+");
                        }             
                               addstr("]");
                          /* addstr("1");
                           addstr("-1");
                           addstr("]");
                            */
			/*
                        *bp++ = '[';
                        for (pll2 = pllnd->entry.Template.ll_ptr1;pll2; pll2= pll2->entry.Template.ll_ptr2)
                          {
			*bp++ = '(';
			cunp_llnd(pll2->entry.Template.ll_ptr1);
			if (pll_range->entry.Template.ll_ptr1->entry.Template.ll_ptr1->entry.Template.ll_ptr1!=NULL) 
			addstr("-");
			addstr("(");
			cunp_llnd(pll_range->entry.Template.ll_ptr1->entry.Template.ll_ptr1->entry.Template.ll_ptr1);
			addstr(")");
		        *
                           if (pll_range->entry.Template.ll_ptr1->entry.Template.ll_ptr1->entry.Template.ll_ptr1->variant == MINUS_OP)
                           addstr("+1"); 
                        
			  }
			else
			addstr("-1");
			pll_range=pll_range->entry.Template.ll_ptr2;
			*bp++ = ')';
		          } *bp++ = ']';
		          }  
                         */
		    }
		}	
		if (in_read_state) /* added by Wu Zhigang */
		  {
		   PTR_TYPE atype;
		   atype = pllnd->entry.array_ref.symbol->type;
		   switch (atype->entry.Template.base_type->variant)
			{
			case T_INT :
			  addstr(" = InputData.readInt();\n");
			  break;
			case T_FLOAT :
			  addstr(" = InputData.readFloat();\n");
			  break;
			case T_DOUBLE :
			  addstr(" = InputData.readDouble();\n");
			  break;
			case T_COMPLEX :
			case T_DCOMPLEX :
			  addstr(" = InputData.readComplex();\n");
			  break;
			case T_CHAR :
			  addstr(" = InputData.readChar();\n");
			  break;
			case T_STRING :
			  addstr(" = InputData.readString();\n");
			  break;
			case T_BOOL :
			  addstr(" = InputData.readBool();\n");
			  break;
			}/* end of switch */
		       /* add IOException catch statement */
		     addstr("	 }catch (IOException e) {  };\n");	
		     } /* end of if */
		break;
	case CONSTRUCTOR_REF	:
		break;
	case ACCESS_REF :
		break;
	case CONS	:
		break;
	case ACCESS	:
		break;
	case IOACCESS	:
		break;
	case PROC_CALL	:
	case FUNC_CALL	:
                addstr(pllnd->entry.Template.symbol->ident);
                /* addstr("_o."); */
		addstr("_c."); /* added by Wy Zhigang */
		/* the above two statements was added by Zheng Qiang to fit for Java */
		addstr(pllnd->entry.Template.symbol->ident);
		*bp++ = '(';
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		*bp++ = ')';
                updat_real_arg(pllnd);
		break;

	case STAR_LIST  : /* added by Wu Zhigang for Conditions such as character str*10 */
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		break;


	case EXPR_LIST	:

		  /* added by Wu Zhigang to deal with Statement */
	   if (in_write_state == 2 ) 
		{
		int NotFinished = 1;/* Whether current part is finished */
	      while (NotFinished) {
		NotFinished = 0; 		
		while (*sFormatStr == ' ')sFormatStr++;
		if (*sFormatStr == '\'')
		  {/* if string */
		  NotFinished = 1;	
		   *bp++='"';
		   sFormatStr++;
		   while (*sFormatStr != '\'')
			{
			*bp++=*sFormatStr++;
			}
		   sFormatStr++;
		   *bp++='"';
		  while (*sFormatStr == ' ')
			sFormatStr++;	
		   if (*sFormatStr == ',')
		     {
			sFormatStr++;
			addstr("+");
			}
		   }/* end of if */
		 while (*sFormatStr==' ' )sFormatStr++;	
		   if (*sFormatStr =='/')
		    {
			NotFinished = 1;
			*bp++='"';
			addstr("\\n");     
	       	      while (*(sFormatStr+1) == '/')
			{
			sFormatStr++;
			addstr("\\n");
			}
			sFormatStr++;
			*bp++='"';
			while (*sFormatStr == ' ')sFormatStr++;
			if (*sFormatStr ==',' )
			  {
			  sFormatStr++;
			  addstr("+");
			  }
			else
			  if (strlen(sFormatStr) != 0)
				addstr("+"); 
		     }/* end of if */
		while (*sFormatStr ==' ')
		 sFormatStr++;
		if (*sFormatStr >= '1' && *sFormatStr <= '9')
		 {
		  int num = *sFormatStr - '0';
		  sFormatStr++;
		  *bp++ = '"';
		  while (*sFormatStr >= '0' && *sFormatStr <= '9')
		   {
		    num=num*10+*sFormatStr - '0';
		    sFormatStr++;
		   }	
		  if (*sFormatStr == 'X' || *sFormatStr == 'x')
		    {
		    int count = 0;
		    for(;count<num;count++)
			*bp++ = ' ';
		    sFormatStr++;	
		    }
		*bp++='"';
		while (*sFormatStr ==' ')sFormatStr++;
		if (*sFormatStr == ',')
 		 {
		  addstr("+");
		  sFormatStr++;
		 }
		NotFinished = 1;
		} /* end of if */	
		   
		if (strlen(sFormatStr) == 0 && FormatSource != NULL)
		   {
		    sFormatStr = FormatSource;
		    NotFinished = 1;
		    addstr("+");
		    *bp++='"';
		    addstr("\\n");
		    *bp++='"';
		    addstr("+");		
		     }		
		} /* end of while -- until some output editor character is met*/
		while (*sFormatStr ==' ')sFormatStr++;
		while (*sFormatStr != ',' && strlen(sFormatStr) != 0 && *sFormatStr != '/')
			sFormatStr++;
		 if (*sFormatStr == ',' || *sFormatStr == '/')
		   sFormatStr++;
			   
		  }
		if (in_common_state == 1)
		  put_tabs(1); /* for common statement,add a table key */
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		if (pllnd->entry.Template.ll_ptr2) {
			if (!in_write_state)/* added by Wu Zhigang for write statement */		
		        	{
			     if (in_common_state == 1  )
				{ /* for naname common statement only */
 				/* addstr(";\n"); */
				}
			      else
				if (in_read_state)	  
			          put_tabs(tab_count);
				 else
				  if (in_common_state != 2 && !in_equi_state)
				    addstr(",");
			   }	
			 else
			  {/*
			   if (FormatSource != NULL && strlen(sFormatStr)==0)
				sFormatStr = FormatSource; 	*/ 
			     addstr("+");
			   }
			cunp_llnd(pllnd->entry.Template.ll_ptr2);
		}
		break;
	case EQUI_LIST	:
		FirstEquiVar = 1;
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		FirstEquiVar = 1;
		cunp_llnd(pllnd->entry.Template.ll_ptr2);
		break;
	case COMM_LIST	:/* added by Wu Zhigang for noname common statement*/
		  {
		  char name[NAMELEN];
		  int seq;
		 if (pllnd->entry.Template.symbol == NULL)
		    strcpy(name,"NonameCommon");
		   else
		  strcpy(name,pllnd->entry.Template.symbol->ident);/*get name*/
                  for(seq = 0;seq < count_of_common;seq++)
		   if (strcmp(name,CommonName[seq]) == 0) /* found it */
			break;
	 	  if (seq >= count_of_common)
		    {
		   CommonName[seq] = malloc(sizeof(char) * NAMELEN);
		   strcpy(CommonName[seq],name);
		   count_of_common++;
		   NamedCommon[seq] = malloc(sizeof(char)*COMMON_BUFFER_LEN);
		   strcpy(NamedCommon[seq],"\n      class ");
		   strcat(NamedCommon[seq],name);
		   strcat(NamedCommon[seq],"{\n");
		   }
		 current_common = seq;	
		 } /* modify pointers and buffers */		 
		  if (bCommonNotInitiated)
		  { 
		  in_common_state = 1;/* common statement initiation */
		  cunp_llnd(pllnd->entry.Template.ll_ptr1);
		  /* addstr(";\n"); */
		  cunp_llnd(pllnd->entry.Template.ll_ptr2);
		  in_common_state = 0;
		  }
		 else /* just for  common statement */
		  {
		   in_common_state = 2;
		   cunp_llnd(pllnd->entry.Template.ll_ptr1);
		   cunp_llnd(pllnd->entry.Template.ll_ptr2);
		   in_common_state = 0;
		  }
		break;
	case VAR_LIST	:
	case CONTROL_LIST	:
		break;
	case RANGE_LIST :
		*bp++ = '[';
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		*bp++ = ']';
		cunp_llnd(pllnd->entry.Template.ll_ptr2);
		break;
	case DDOT	:
		if (in_subString_val) {/* added by Wu Zhigang for subString */
		 cunp_llnd(pllnd->entry.Template.ll_ptr1);
		 }
		 else {
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		addstr(":"); 
		cunp_llnd(pllnd->entry.Template.ll_ptr2);
		 }
		break;
	case COPY_NODE :
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		addstr("#");
		cunp_llnd(pllnd->entry.Template.ll_ptr2);
		break;
	case VECTOR_CONST :	/* NEW ADDED FOR VPC++	*/
		addstr("[ ");
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		addstr(" ]"); 
		break ;
	case INIT_LIST:
		addstr("{ ");
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		addstr(" }"); 
		break ;
	case BIT_NUMBER:
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		addstr(" : ");
		cunp_llnd(pllnd->entry.Template.ll_ptr2);
		break ;
	case DEF_CHOICE :
	case SEQ	:
		break;
	case SPEC_PAIR	:
		if (pllnd->entry.Template.ll_ptr2->variant == LABEL_REF)
		  {/* added by Wu Zhigang to get format statement for I/O */
		   int i;
		  sFormatStr = pllnd->entry.Template.ll_ptr2->entry.label_list.lab_ptr->statbody->entry.Template.ll_ptr1->entry.string_val;
		  sFormatStr++;/* skip first '(' */
		  /*FormatSource = malloc(sizeof(char)*(strlen(sFormatStr)+1));
		  for(i=0;i<strlen(sFormatStr)-1;i++)
		   *(FormatSource+i) = *(sFormatStr+i);
		  *(FormatSource+i) = '\0';*/
		if (*(sFormatStr+strlen(sFormatStr)-1) == ')')
		  *(sFormatStr+strlen(sFormatStr)-1) = '\0';/*delete last ')' */		
		  FormatSource = sFormatStr ;/* save the pointer */ 
		}	
		break;

	case EQ_OP	:
	case LT_OP	:
	case GT_OP	:
	case NOTEQL_OP	:
	case LTEQL_OP	:
	case GTEQL_OP	:
	case ADD_OP	:
	case SUBT_OP	:
	case OR_OP	:
	case MULT_OP	:
	case DIV_OP	:
	case AND_OP	:
	case XOR_OP	:
	case POINTST_OP :	/* New added for VPC */
	case LE_OP	:	/* New added for VPC *//*Duplicated*/
	case GE_OP	:	/* New added for VPC *//*Duplicated*/
	case NE_OP	:	/* New added for VPC *//*Duplicated*/

	case PLUS_ASSGN_OP:
	case MINUS_ASSGN_OP:
	case AND_ASSGN_OP:
	case  IOR_ASSGN_OP:
	case  MULT_ASSGN_OP:
	case  DIV_ASSGN_OP:
	case MOD_ASSGN_OP:
	case  XOR_ASSGN_OP:
	case  LSHIFT_ASSGN_OP:
	case  RSHIFT_ASSGN_OP :

	case ARITH_ASSGN_OP:
	case ASSGN_OP	:	/* New added for VPC */
	case BITAND_OP	  :	/* New added for VPC */
	case BITOR_OP	  :	/* New added for VPC */
	case LSHIFT_OP	       : /* New added for VPC */
	case RSHIFT_OP	       : /* New added for VPC */
	case MOD_OP :	/* New added for VPC */
	    {
		    int i, j ;
		    PTR_LLND p;

		    i = pllnd->variant ;
		    p = pllnd->entry.Template.ll_ptr1 ;
		    j = p->variant;
		    if ( cprecedence(i) < cprecedence(j) ) {
			    *bp++ = '(';
			    cunp_llnd(p);
			    *bp++ = ')';
			    if (pllnd->variant != ARITH_ASSGN_OP)
				    addstr(cop_name[mapping(i)] );
			    else
				    gen_op(pllnd->entry.Template.symbol->variant); 
		    } else {
			    cunp_llnd(p);
			    if (pllnd->variant != ARITH_ASSGN_OP)
				    addstr(cop_name[mapping(i)]);
			    else
				    gen_op(pllnd->entry.Template.symbol->variant);
		    }
		    p = pllnd->entry.Template.ll_ptr2;
		    j = p->variant;
		    if ( cprecedence(i) <= cprecedence(j)) {
			    *bp++ = '(';
			    cunp_llnd(p);
			    *bp++ = ')';
		    } else
			    cunp_llnd(p);
		    break ;
	    }
	case SUB_OP   : 	/* duplicated unary minus  */
	case MINUS_OP	:	/* unary operations */
	case UNARY_ADD_OP      : /* New added for VPC */
	case BIT_COMPLEMENT_OP : /* New added for VPC */
	case NOT_OP	:
	case DEREF_OP :
	case SIZE_OP	  :	/* New added for VPC */
	case ADDRESS_OP   :	/* New added for VPC */
	    {
		    int i, j;
		    PTR_LLND p;

		    i = pllnd->variant ;
		    p = pllnd->entry.Template.ll_ptr1 ;
		    j = p->variant;
		    addstr(cop_name[mapping(i)] );
		    if ( cprecedence(i) < cprecedence(j) ) {
			    *bp++ = '(';
			    cunp_llnd(p);
			    *bp++ = ')';
		    } else
			    cunp_llnd(p);
	    } 
		break;
	case SAMETYPE_OP      : 	      /* New added for VPC */
	    addstr("SameType (");
	    cunp_llnd(pllnd->entry.Template.ll_ptr1);
	    addstr(" , ");
	    cunp_llnd(pllnd->entry.Template.ll_ptr2);
	    addstr(")");
		break;
	case MINUSMINUS_OP:	/* New added for VPC */
	case PLUSPLUS_OP  :	/* New added for VPC */
	    {
		    int i ,j ;
		    PTR_LLND p;

		    i = pllnd->variant;
		    if	(p = pllnd->entry.Template.ll_ptr1) {
			    j = p->variant;
			    addstr(cop_name[mapping(i)] );
			    if ( cprecedence(i) < cprecedence(j) ) {
				    *bp++ = '(';
				    cunp_llnd(p);
				    *bp++ = ')';
			    } else
				    cunp_llnd(p);
		    } else {
			    p = pllnd->entry.Template.ll_ptr2 ;
			    j = p->variant;
			    if ( cprecedence(i) < cprecedence(j) ) {
				    *bp++ = '(';
				    cunp_llnd(p);
				    *bp++ = ')';
			    } else
				    cunp_llnd(p);
			    addstr(cop_name[mapping(i)] );
		    }
	    } 
		break;

	case STAR_RANGE :
		addstr(" : ");
		break;
	case FUNCTION_OP :	/* New added for VPC */
		*bp++ = '(';
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		*bp++ = ')';		    
		*bp++ = '(';
		cunp_llnd(pllnd->entry.Template.ll_ptr2);   
		*bp++ = ')';		    
		break ;
	case CLASSINIT_OP :	/* New added for VPC */
	    {
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		*bp++ = '(';
		cunp_llnd(pllnd->entry.Template.ll_ptr2);
		*bp++ = ')';
	    }
		break ;
	case DELETE_OP:
		 addstr("delete ");
		 if (pllnd->entry.Template.ll_ptr2) {
		   *bp++ ='[';
		   cunp_llnd(pllnd->entry.Template.ll_ptr2);
		   addstr("] ");
		 }
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		break;
	case SCOPE_OP:
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		addstr("::");
		cunp_llnd(pllnd->entry.Template.ll_ptr2);
		break;
	case NEW_OP:
		{ PTR_LLND pllnd1;
		  addstr("new ");
		  pllnd1 = pllnd->entry.Template.ll_ptr1;
		  gen_simple_type_2(pllnd1->type,BFNULL,global_tab);
		  if (pllnd->entry.Template.ll_ptr2) {
		    *bp++= '(';
		    cunp_llnd(pllnd->entry.Template.ll_ptr2);
		    addstr(") ");
		  }
		  break;
		}
	case CAST_OP :		/* New added for VPC */
		*bp++ = '(';
		gen_simple_type_2(pllnd->type, BFNULL, global_tab);
		*bp++ = ')';
		*bp++ = ' ';
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		break;
	case EXPR_IF	  :	/* New added for VPC */
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		addstr(" ? ");
		cunp_llnd(pllnd->entry.Template.ll_ptr2);
		break;
	case EXPR_IF_BODY :	/* New added for VPC */
		cunp_llnd(pllnd->entry.Template.ll_ptr1);
		addstr(" : ");
		cunp_llnd(pllnd->entry.Template.ll_ptr2);
		break;
	case FUNCTION_REF :	/* New added for VPC */
		addstr(pllnd->entry.Template.symbol->ident);
		*bp++ = '(';
		/*		cunp_llnd(pllnd->entry.Template.ll_ptr1);   */
		*bp++ = ')';
		break ;
	case LABEL_REF: 	/* Fortran Version, For VPC we need more */
	    { char sb[64];
	    if (!in_write_state) /* not print statement */	
	     {		
	      sprintf(sb, "%d", pllnd->entry.label_list.lab_ptr->stateno);
	      addstr(sb);
		}
	       else /* current bfnd node Is print statement */
		{
		int i; 
		sFormatStr = pllnd->entry.label_list.lab_ptr->statbody->entry.Template.ll_ptr1->entry.string_val;
		
	/* FormatSource = malloc(sizeof(char)*(strlen(sFormatStr)+1)); */
		sFormatStr++;/* delete first '(' */
		/*
		for(i=0;i < strlen(sFormatStr)-1 ;i++)
		  *(FormatSource+i)=*(sFormatStr+i);
		*(FormatSource+i)='\0';*/
		 /* delete last ')' */
		if (*(sFormatStr+strlen(sFormatStr)-1) == ')') 
		  *(sFormatStr+strlen(sFormatStr)-1) = '\0';
		FormatSource = sFormatStr; /* save the pointer */	
		}
	      break;
	    }
	default :
		break;
	}
}

static int
is_param_decl(var_bf, functor)
	PTR_BFND var_bf ;
	PTR_SYMB functor ;
{
	PTR_LLND flow_ptr = LLNULL, lpr = LLNULL;
	PTR_SYMB s = SMNULL, s1=SMNULL;

	switch (var_bf->variant) {
	case VAR_DECL :
	case ENUM_DECL:
	case CLASS_DECL:
	case UNION_DECL:
	case STRUCT_DECL:
	case DERIVED_CLASS_DECL :
		lpr = var_bf->entry.Template.ll_ptr1 ;
		for (flow_ptr = lpr; flow_ptr ; flow_ptr = flow_ptr->entry.Template.ll_ptr1) {
			if ((flow_ptr->variant == VAR_REF) ||
			    (flow_ptr->variant == ARRAY_REF) ||
			    (flow_ptr->variant == FUNCTION_REF) ) break ;
		}
		if (!flow_ptr)
			return(0);

		s1 = functor->entry.member_func.in_list;
		for (s = s1; s ;  s = s->entry.var_decl.next_in)
			if (flow_ptr->entry.Template.symbol == s)
				return(1);
		break;
	default :
		break;
	}
	return(0) ;
}


static int
this_is_decl(variant)
int variant ;
{
	switch(variant) {
	case CLASS_DECL :
	case UNION_DECL :
	case STRUCT_DECL :
	case ENUM_DECL :
	case VAR_DECL :
	case DERIVED_CLASS_DECL:
		return(1);
	default :
		break;
	}
	return(0);
}


static int
not_explicit(s, pbf)
	PTR_SYMB  s ;
	PTR_BFND pbf ;
{
	PTR_BLOB blob ;
	PTR_LLND lptr1;
	PTR_SYMB symbptr;

	for (blob = pbf->entry.Template.bl_ptr1 ; blob ; blob = blob->next ) {
		if (!this_is_decl(blob->ref->variant )) return(1);
		for (lptr1=blob->ref->entry.Template.ll_ptr1 ; lptr1; lptr1 = lptr1->entry.Template.ll_ptr2) {
			symbptr = find_declarator(lptr1);
			if ( s == symbptr) return(0);
		}
	}
	return(1);
}


static int
not_class(pbf)
PTR_BFND pbf;
{
  switch(pbf->variant) {
  case GLOBAL :
  case CLASS_DECL :
  case UNION_DECL :
  case STRUCT_DECL :
  case ENUM_DECL :
  case FUNC_HEDR :
  case DERIVED_CLASS_DECL:  return(0);
    default :		    return(1);
  }
}

int cdrtext(bfptr,tab,curh,maxh)
PTR_BFND bfptr;
int curh,maxh;
{
        int lev;
        register PTR_BLOB b, p;
        int      left_param ;
	int token;

        left_param = 0;
        lev = maxh-curh;

        global_tab = tab ;
        cunp_bfnd(tab, bfptr);
        global_tab = tab ;
/*
        if ((current_proc == global_bfnd) && (bfptr->control_parent == global_bfnd))
                return(token);
*/

        if ((basket_needed(bfptr,1) > 1)&&(not_class(bfptr)))
           {   put_tabs(tab); 
	      addstr("{ \n");
	   }
	  
        for (b = bfptr->entry.Template.bl_ptr1; b; b = b->next)
	  {
/*               PTR_CMNT cmnt = b->ref->entry.Template.cmnt_ptr;
                 if (cmnt)
                       while (cmnt != NULL && cmnt->type == FULL) {
                                        addstr(cmnt->string );
                                        addstr( "\n" );
                                        cmnt = cmnt->next;
                                }
*/
                  switch(bfptr->variant){
	          case CLASS_DECL :
		  case COLLECTION_DECL:
                  case UNION_DECL :
                  case ENUM_DECL:
                  case STRUCT_DECL :
                  case DERIVED_CLASS_DECL : break ;
                  case FUNC_HEDR :
                      if (left_param==0)
                            {
                             if (!is_param_decl(b->ref,bfptr->entry.Template.symbol))
			       {   put_tabs(tab); addstr("{ \n");
                                   left_param= 1 ;
				 }

                           }
                       token = cdrtext(b->ref,tab+1,curh+1,maxh);
                       break ; 
                  default :
                          token = cdrtext(b->ref,tab+1,curh+1,maxh);
	          }
/*                 if (cmnt && cmnt->type != FULL)
                     {  addstr( cmnt->string );
                        addstr( "\n" );
		      }
*/
	     } 
       if (bfptr->variant == FUNC_HEDR)
         {
                if (left_param == 0)  {
                         put_tabs(tab); addstr("{ \n");
		       }
                put_tabs(tab); addstr("} \n");
	    }

        if ((basket_needed(bfptr, 1) > 1)&&(not_class(bfptr)))
           {   put_tabs(tab); addstr("} \n");
	   }

        if (basket_needed(bfptr,2) > 0)
	  {    put_tabs(tab); addstr("else \n");
	     }
        if (basket_needed(bfptr,2) > 1)
           {   put_tabs(tab); addstr("{ \n");
	   }


        for (b = bfptr->entry.Template.bl_ptr2; b; b = b->next)
          {                  
              PTR_CMNT cmnt = b->ref->entry.Template.cmnt_ptr;
                       token = cdrtext(b->ref,tab+1,curh+1,maxh);
   
          }

        if (basket_needed(bfptr,2) > 1)
           {   put_tabs(tab); addstr("} \n");
	   }
/*        if (cmnt && cmnt->type != FULL)
            while  (cmnt && cmnt->type != FULL)
                     {  tm_put_string(Wid,cmnt->string,token);
                        cmnt =cmnt->next ;
		      }
         addstr( "\n" );
*/
        return (token);


 }






static int 
basket_needed(bf, index)
	PTR_BFND  bf ;
	int index ;
{
	PTR_BLOB blob1 ,blob ;

	switch (index) {
	case 1 :
		if (bf->variant == FUNC_HEDR || bf->variant == BASIC_BLOCK)
			return(2);
		blob = bf->entry.Template.bl_ptr1 ;
		if (blob == NULL)  return(0) ;
		if (((blob1= blob->next) == NULL) || 
		    (blob1->ref->variant == CONTROL_END)) return(1);
		break;
	case 2 :
		blob = bf->entry.Template.bl_ptr2 ;
		if (!blob)  return(0) ;
		if (((blob1= blob->next) == NULL) ||
		    (blob1->ref->variant == CONTROL_END)) return(1);
		break;
	}
	return(2) ;
}


static void
cunp_blck(bfptr, tab)
	PTR_BFND bfptr;
	int	 tab;
{
    PTR_BLOB b;
    int  left_param ;

    left_param = 0;
    cunp_bfnd(tab, bfptr);

    if ((basket_needed(bfptr,1) > 1)&&(not_class(bfptr))) {
	put_tabs(tab);
	addstr("{\n");
    }
	  
    for (b = bfptr->entry.Template.bl_ptr1; b; b = b->next) {
	switch(bfptr->variant) {
	case CLASS_DECL :
	case UNION_DECL :
	case ENUM_DECL:
	case STRUCT_DECL :
	case DERIVED_CLASS_DECL :
	    break ;
	case FUNC_HEDR :
	    if (left_param==0)
		if (!is_param_decl(b->ref,bfptr->entry.Template.symbol)) {
		    put_tabs(tab);
		    addstr("{\n");
		    left_param= 1 ;
		}
	    cunp_blck(b->ref, tab+1);
	    break ;
	case CONTROL_END:
	    break; 
	default :
	    cunp_blck(b->ref, tab+1);
	    break;
	}
    } 
    if (bfptr->variant == FUNC_HEDR) {
	if (left_param == 0) {
	    put_tabs(tab);
	    addstr("{\n");
	}
	put_tabs(tab);
	addstr("}\n");
    }

    if ((basket_needed(bfptr, 1) > 1)&&(not_class(bfptr))) {
	put_tabs(tab);
	addstr("}\n");
    }

    if (basket_needed(bfptr,2) > 0) {
	put_tabs(tab);
	addstr("else\n");
    }
    if (basket_needed(bfptr,2) > 1) {
	put_tabs(tab);
	addstr("{\n");
    }

    for (b = bfptr->entry.Template.bl_ptr2; b; b = b->next)
	cunp_blck(b->ref, tab+1);

    if (basket_needed(bfptr,2) > 1) {
	put_tabs(tab);
	addstr("}\n");
    }
}


/* find_declarator :
 * <1> Given a ll_node <expr_list> to follow ll_ptr1 to find declarator
 * <2> return the symb pointer
 */
static PTR_SYMB
find_declarator(expr_list)
	PTR_LLND expr_list ;
{
	PTR_SYMB symb;
	PTR_LLND p ;

	if (! expr_list)
		return(SMNULL);
	symb = SMNULL ;
	for ( p = expr_list->entry.Template.ll_ptr1 ; p ;   ) {
	    switch (p->variant) {
		case STAR_LIST :/* added by Wu Zhigang to deal with conditions such as "character llsr*5" */
		case BIT_NUMBER:
		case ASSGN_OP :
		case ARRAY_OP:
		case FUNCTION_OP :
		case CLASSINIT_OP:
		case ADDRESS_OP:
		case DEREF_OP : p = p->entry.Template.ll_ptr1 ;
			break ;
		case FUNCTION_REF:
		case ARRAY_REF:
		case VAR_REF:
			symb = p->entry.Template.symbol ;
			p = LLNULL ;
			break ;
		}
	}
	return(symb);
}


static void
gen_func_hedr(functor, pbf, tabs)
	PTR_SYMB functor ;
	PTR_BFND pbf ;
	int	 tabs ;
{
	PTR_SYMB s ;
	PTR_TYPE q ;
	PTR_LLND pllnd;
	int i;

	for (q = functor->type; q ;	) { 
		switch ( q->variant) {
		case T_POINTER : 
			*bp++ = '*';
			q = q->entry.Template.base_type ;
			break;
                case T_REFERENCE:
                       *bp++ = '&';
                       q = q->entry.Template.base_type ;
                       break;
		default:	/* It might need more for complicated case */
			q = (PTR_TYPE) NULL ;
		}
	}
        if (is_scope_op_needed(pbf,functor)) {
           addstr(functor->entry.member_func.base_name->ident);
           addstr("::");
        }

        if( !strcmp(functor->ident,"main"))
           addstr(" void "); /* Added by Zheng Qiang to fit for java */

	addstr(functor->ident);
	*bp++ = '(';

        if( !strcmp(functor->ident,"main"))
           addstr("String args[]");
        else  /* Above three is modified by Zheng Qiang to fit for java */
	for ( i=0, s = functor->entry.member_func.in_list ; s ; i++ ) {
		if (i)	*bp++ = ',';  
		if (not_explicit(s, pbf)) {
			gen_simple_type(s->type, BFNULL, tabs);
			for (q = s->type; q ;	) {
				switch ( q->variant) {
				case T_POINTER : 
					*bp++ = '*';
					q = q->entry.Template.base_type;
					break;
	                        case T_REFERENCE:
                                        *bp++ ='&';
                                         q = q->entry.Template.base_type ;
                                         break;
				default: /* It might need more for complicated case */
					q = (PTR_TYPE) NULL;
				}
			}
	  
		}
		addstr(s->ident);
		s = s->entry.var_decl.next_in;
	}
	*bp++ = ')';
	 /* added by Wu Zhigang to declare IOException */
	addstr("\n");
	put_tabs(3);
	/* addstr("throws IOException \n"); */
        pllnd = pbf->entry.Template.ll_ptr1;
        pllnd = pllnd->entry.Template.ll_ptr1;
        if (pllnd &&(pllnd->variant == BIT_NUMBER)){
            addstr(" : ");
            cunp_llnd(pllnd->entry.Template.ll_ptr2);
            }
} 

int
is_scope_op_needed(pbf,functor)
PTR_BFND pbf;
PTR_SYMB functor;
{
  PTR_BFND parent;

  if (functor->variant!=MEMBER_FUNC) return(0);
  parent = pbf->control_parent;
  if (parent->variant==GLOBAL)       return(1);
  else                               return(0);

}

char *
cunparse_llnd(llnd)
	PTR_LLND llnd;
{
	int len;
	char *p;

	bp = buffer;	/* reset the buffer pointer */
	cunp_llnd(llnd);
	*bp++ = '\n';
	*bp++ = '\0';
	len = (bp - buffer) + 1; /* calculate the string length */
	p = malloc(len);	/* allocate space for returned value */
	strcpy(p, buffer);	/* copy the buffer for output */
	*buffer = '\0';
	return p;
}


char *
cunparse_bfnd(bif)
	PTR_BFND bif;
{
	char *p;
	int len;

	first = 1;	/* Mark this is the first bif node */
	bp = buffer;	/* reset the buffer pointer */
	cunp_bfnd(0, bif) ;
	*bp++ = '\0';
	len = (bp - buffer) + 1; /* calculate the string length */
	p = malloc(len);	/* allocate space for returned value */
	strcpy(p, buffer);	/* copy the buffer for output */
	*buffer = '\0';
	return p;

}


static void
gen_declarator(s)
	PTR_SYMB s ;
{
	PTR_TYPE q ;
	char * old_bp ;

	clean(temp_buf);
	put_right(s->ident,temp_buf);
	for (q = s->type; q ;	) { 
		switch ( q->variant) {
		case T_POINTER : 
			put_left("*",temp_buf);
			q = q->entry.Template.base_type ;
			break;
		case T_ARRAY :
			clean(temp2_buf);
			put_right(buffer,temp2_buf);
			clean(buffer);
			old_bp = bp ;
			bp = buffer ;
			cunp_llnd(q->entry.ar_decl.ranges);
			bp = old_bp;
			put_right(buffer,temp_buf);
			clean(buffer);
			put_right(temp2_buf,buffer);
			q = q->entry.Template.base_type ;
			break;
		case T_FUNCTION:
			put_left("(",temp_buf);
			put_right(")",temp_buf);
			put_right("()",temp_buf);
			q = q->entry.Template.base_type ;
			break;

		default:	/* It might need more for complicated case */
			q = (PTR_TYPE) NULL ;
		}
	}
	addstr(temp_buf);	
}


char *
cunparse_symb(symb)
	PTR_SYMB symb;
{
	int len;
	char *p;

	first = 1;		/* Mark this is the first bif node */
	bp = buffer;		/* reset the buffer pointer */
	gen_simple_type(symb->type,BFNULL,0);
	gen_declarator(symb);
	*bp++ = '\n';
	*bp++ = '\0';
	len = (bp - buffer) + 1; /* calculate the string length */
	p = malloc(len);	/* allocate space for returned value */
	strcpy(p, buffer);	/* copy the buffer for output */
	*buffer = '\0';
	return p;
}


/****************************************************************
 *								*
 *	    for cunparse_type					*
 *								*
 ****************************************************************/

char *
cunparse_type(q_type)
PTR_TYPE q_type;
{
	int len;
	char *p;

	first = 1;	/* Mark this is the first bif node */
	bp = buffer;	/* reset the buffer pointer */
	gen_simple_type_2(q_type,BFNULL,0);
	*bp++ = '\n';
	*bp++ = '\0';
	len = (bp - buffer) + 1; /* calculate the string length */
	p = malloc(len);	/* allocate space for returned value */
	strcpy(p, buffer);	/* copy the buffer for output */
	*buffer = '\0';
	return p;
}


char *
cunparse_blck(bif)
	PTR_BFND bif;
{
	int len;
	char *p;

	first = 1;		/* Mark this is the first bif node */
	bp = buffer;		/* reset the buffer pointer */

	cunp_blck(bif, 0);
	*bp++ = '\0';
	len = (bp - buffer) + 1; /* calculate the string length */
	p = malloc(len);	/* allocate space for returned value */
	strcpy(p, buffer);	/* copy the buffer for output */
	*buffer = '\0';
	return (p);
}

/* author :     Zheng Qiang
   function:   
              
   input  : */ 
void
gen_class_var_decl(int tabs,PTR_BFND pbf)
{
int      para_nu; /* The number of parameters */
int	 i;
char	 *index="   ";
PTR_BFND parent;
PTR_SYMB sp;
/* pbf should be a bfnd whose type is FUNC_HEDR */

if(pbf->variant = FUNC_HEDR) {

   para_nu = pbf->entry.function.func_symb->entry.func_decl.num_input;
   for ( sp = pbf->entry.function.func_symb->entry.func_decl.in_list,i = 1;
         i <= para_nu;
         sp = sp->entry.var_decl.next_in, i++) {
	addstr("static ");
	gen_simple_type(sp->type, pbf, tabs) ;

    /* addstr(sp->ident); */
	sprintf(index,"%d",i);
	addstr("argu");
	addstr(index);
	addstr("_cv;\n ");
	put_tabs(tabs);
        }
   }
}

/* author : 	Zheng Qiang 
   function:	to geneate some strings which can change 
		the real argument according to the function envoked
   input  :	the llnd whose variant is FUNC_CALL */
   
void
updat_real_arg(PTR_LLND lp)
{
PTR_SYMB  tmp_symb;
PTR_LLND  tmp_llnd,tmp_llnd1;
int	  i;
char *	  index="   ";

if(lp->variant == FUNC_CALL || lp->variant == PROC_CALL ) {
	tmp_symb = lp->entry.proc.symbol->entry.func_decl.in_list;

	if(!tmp_symb) /*Need modification*/ {
	   /* tmp_symb = lp->entry.proc.symbol->next_symb->entry.func_decl.in_list; */
	   tmp_symb = findFuncDeclSymb(lp->entry.proc.symbol);
	   tmp_symb = tmp_symb->entry.func_decl.in_list;
	}

	for(tmp_llnd = lp->entry.proc.param_list, i=1;
	    tmp_llnd;
		i++,
	    tmp_symb = tmp_symb->entry.var_decl.next_in,
	    tmp_llnd = tmp_llnd->entry.list.next)
		switch (tmp_llnd->entry.list.item->variant) {
			case  VAR_REF :
				put_right(tmp_llnd->entry.list.item->entry.var_ref.symbol->ident,args_buf);	
				put_right(" = ",args_buf);
				put_right(lp->entry.proc.symbol->ident,args_buf);
				put_right("_c.",args_buf);
				/* put_right(tmp_symb->ident,args_buf);
				 * put_right("_cv;\n",args_buf); */
				sprintf(index,"%d",i);
				put_right("argu",args_buf);
				put_right(index,args_buf);
				put_right("_cv;\n ",args_buf);
				break;
			case  ARRAY_REF :
     				put_right(tmp_llnd->entry.list.item->entry.array_ref.symbol->ident,args_buf);
     				for (tmp_llnd1 = tmp_llnd->entry.list.item->entry.array_ref.index;
				     tmp_llnd1; 
				     tmp_llnd1 = tmp_llnd1->entry.list.next) {
      				        put_right("[",args_buf);
					switch(tmp_llnd1->entry.list.item->variant){
						case	VAR_REF:
							put_right(tmp_llnd1->entry.list.item->entry.Template.symbol->ident,args_buf);
							break;
						case	ADD_OP:
							put_right(tmp_llnd1->entry.list.item->entry.Template.ll_ptr1,args_buf);
							put_right('+',args_buf);
							put_right(tmp_llnd1->entry.list.item->entry.Template.ll_ptr1,args_buf);
							break;
						case	SUBT_OP:
							put_right(tmp_llnd1->entry.list.item->entry.Template.ll_ptr1,args_buf);
							put_right('-',args_buf);
							put_right(tmp_llnd1->entry.list.item->entry.Template.ll_ptr1,args_buf);
							break;
						case	MULT_OP:
							put_right(tmp_llnd1->entry.list.item->entry.Template.ll_ptr1,args_buf);
							put_right('*',args_buf);
							put_right(tmp_llnd1->entry.list.item->entry.Template.ll_ptr1,args_buf);
							break;
						case	DIV_OP:
							put_right(tmp_llnd1->entry.list.item->entry.Template.ll_ptr1,args_buf);
							put_right('/',args_buf);
							put_right(tmp_llnd1->entry.list.item->entry.Template.ll_ptr1,args_buf);
							break;
					}
      				        put_right("]",args_buf);
                                put_right(" = ",args_buf);
                                put_right(lp->entry.proc.symbol->ident,args_buf);
                                put_right("_c.",args_buf);
                                /* put_right(tmp_symb->ident,args_buf);
								 * put_right("_cv"); */
								sprintf(index,"%d",i);
								put_right("argu",args_buf);
								put_right(index,args_buf);
								put_right("_cv;\n ",args_buf);
                                put_right(";\n",args_buf);
				}
				break;
		}
}
}
