/*******************************************************************************
    Semantic check about HPF align directive
    written by Wang Zhenlin
*******************************************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "tags.h"
#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"

#include "defnodes.h"
#include "dep.h"
#include "dep_struct.h"
#include "decl.h"
 
#include "exglobal.h"

int align_attr_smtc(var_list,align_attr,isAlign)
PTR_LLND var_list;
PTR_LLND align_attr;
int      isAlign;
{
     PTR_SYMB alignee,align_target,sym,symbol;
     int      alignee_dims,align_source_num,align_target_dims;
     PTR_LLND align_source,align_with,cur_llnd;
     int      have_star;
     PTR_LLND llndA, llndB; /* added by LY, get align-subscript */
     PTR_LLND exprList,expr;
     int      err_code,no;
	
	llndA = (PTR_LLND) malloc(sizeof(PTR_LLND));
	llndB = (PTR_LLND) malloc(sizeof(PTR_LLND));
     
      /*get dimension of align_target*/
     if (align_attr == LLNULL) /*no align source and align target*/
         return 1;

     align_source = align_attr->entry.Template.ll_ptr1;
     align_with = align_attr->entry.Template.ll_ptr2;
		/* by zheng.gb */
     align_target=align_with->entry.Template.ll_ptr2->entry.Template.symbol;
     
     if (align_source == LLNULL && align_with == LLNULL)
        return 1;

     /* add by LY, check for global symbol */
/*					modified by zheng.gb
     check_leaf_sym(align_source);
     check_leaf_sym(align_with);
     check_leaf_sym(var_list);
*/

     /* added by LY, to check PURE function */
        if ( is_in_pure() && !isAlign)
                error3(325);

     /*There exist starts before align_source or align_with*/     
     have_star = 0;
     if (align_with != LLNULL && align_with->entry.Template.ll_ptr1 != LLNULL)  
         have_star = 1;

     /* star can not be in front of align_source or align_with in realign stmt*/
     if (have_star && !isAlign)
        error1(310);


     if (align_source == LLNULL ){
        align_source_num = -1;
     }
     else {
        align_source_num = 0;
	while (align_source != LLNULL) {
                align_source_num++;
		if (  align_source->entry.Template.ll_ptr1->variant != STAR_OP
		   || align_source->entry.Template.ll_ptr1->variant != COLON_OP)
  	           cur_llnd = align_source->entry.Template.ll_ptr1->entry.Template.ll_ptr1;

		/* add by zheng.gb */      
		if (align_source->entry.Template.ll_ptr1->variant==VAR_REF){
     			check_leaf_sym(align_source->entry.Template.ll_ptr1);
			symbol=align_source->entry.Template.ll_ptr1->
				entry.Template.symbol;
/*
			sym=search_symb_ref(symbol);
			if (sym != symbol)  {
				align_source->entry.Template.ll_ptr1->
					entry.Template.symbol=sym;
				symbol->scope = BFNULL;	
				symbol= sym;
			}
*/
				/*  align dummy is of integer type ? */
			if (!isIntegerType(symbol->type))
				error3(224,symbol->ident);
		}

                align_source = align_source->entry.Template.ll_ptr2;
	 } /*while ; go through every align_source*/
     }  


     while (var_list != LLNULL){ /*check every alignees*/

        /* get dimensions of alignee*/
        alignee=var_list->entry.Template.ll_ptr1->entry.Template.symbol;

        /* add by LY, check for global symbol */
        check_leaf_sym(var_list->entry.Template.ll_ptr1);

        if (isSubobject(alignee)) /*subobject can not alignd*/
          error3(301,alignee->ident);
       else
          if (alignee->type->variant == T_ARRAY)
            alignee_dims=alignee->type->entry.ar_decl.num_dimensions;
         else
            alignee_dims=0;   /*scalar*/
      
         /*if existing star infront of align_source or align_with, alignee 
          should have INHERIT attribute*/
/*				comment by zheng.gb 
       if (isAlign && have_star && !have_attribute(alignee,INHERIT_BIT)) 
          error3(302,alignee->ident);
*/
       
       /*(re)alignee should not have DISTRIBUTE attribute*/
       if (have_attribute(alignee,DISTRIBUTE_BIT)) 
          error3(307,alignee->ident);
       
       /*realignee should have DYNAMIC attribute*/
       if (!isAlign && !have_attribute(alignee,DYNAMIC_BIT))
          error3(311,alignee->ident);

        /* added by LY, to check PURE function */
        if (is_in_pure() && is_pure_local_var(alignee) && alignee->scope!=align_target->scope)
                error3(323, alignee->ident);

       if (align_source_num != -1 && align_source_num != alignee_dims)
          error3(312,alignee->ident);

       /*add attr pointer in symbol table*/
       alignee->entry.var_decl.hpfattr = align_attr;

       var_list = var_list ->entry.Template.ll_ptr2; 
     }


     /* added by LY, call Zheng G.B.'s function to check align-subscript */
	no = 0;
     for (exprList=align_with->entry.Template.ll_ptr2->entry.Template.ll_ptr1;
		exprList!=LLNULL; exprList=exprList->entry.Template.ll_ptr2)
     {
		/* add by zheng.gb for check if is specification expression */	
	expr = exprList->entry.Template.ll_ptr1;
	no++;

	/* if not expression do not count a*x + b */
	if (expr->variant == STAR_OP || expr->variant == DDOT )
		continue;

	check_expr_type(expr);
	if (!isInteger(exprList->entry.Template.ll_ptr1))
		error2(225,no);

     	err_code = get_a_b(align_attr->entry.Template.ll_ptr1,
		exprList->entry.Template.ll_ptr1, &llndA, &llndB);
	if (err_code) error1(err_code);
	if (llndA) {
		if (check_initialization_expr(llndA)) {
			comput_const_expr(llndA,0);
		}
	}
	if (llndB) {
		if (check_initialization_expr(llndB)) {
			comput_const_expr(llndB,0);
		}
	}
/* for test */
/*
	exprList->entry.Template.ll_ptr1=llndA;
	exprList->entry.Template.ll_ptr2=llndB;
	break;
*/
     }

}

int is_pure_local_var(pVar)
PTR_SYMB pVar;
{
	if (pVar->scope->entry.procedure.proc_symb->attr & PURE_BIT)
		return 1;
	else return 0;
}
