/*************************************************************************

		Multi.c -- Separate compilation

written by Zheng Gengbin
*************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include <stdio.h>

#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"
#include "defnodes.h"
#include "dep.h"
#include "dep_struct.h"
#include "tags.h"
#include "decl.h"

#include "exglobal.h"


char *gen_mod_name(mod_name)
char *mod_name;
{
	char *outname;

	if (!mod_name )
     		return NULL;

	outname = (char *) malloc((unsigned)(strlen(mod_name)+4));

	strcpy (outname,mod_name);
	strcat(outname,".mod");
	return outname;
}


/************************************************************************/
/*			load_mod_files(root)                            */
/*                                                                      */
/*          load module files recursively                               */
/************************************************************************/
int load_mod_files(node)
PTR_MOD node;
{
	if (node==(PTR_MOD)NULL) return ;
	if (node->lp)
		load_mod_files(node->lp);
	read_mod_nodes(fi,gen_mod_name(node->name));
	if (node->rp)
		load_mod_files(node->rp);
}


/*************************************************************************/
/*                       write_mod_from_dep                              */
/*                                                                       */
/*  write module symbol table to .mod file */
/*************************************************************************/
int write_mod_from_dep(bfnd)
PTR_BFND bfnd;
{
	PTR_FILE  mod_fi;
	PTR_SYMB modsym;
	FILE      *fd;
	char      *modfilename;

	modsym=bfnd->entry.Template.symbol;
	modfilename = gen_mod_name(modsym->ident);

	write_mod_nodes(fi,bfnd,modfilename);
}


int write_modules()
{
	PTR_BFND bfnd;
	PTR_BLOB blob;
	
	bfnd = fi->global_bfnd;
	for (blob=bfnd->entry.Template.bl_ptr1; blob; blob=blob->next) 
	{
		bfnd=blob->ref;
		if (bfnd->variant==MODULE_STMT)
		write_mod_from_dep(bfnd);
	}
}






