
/*******************************************************************
!*                  ICPSEP Homework Program #                      *
!*                                                                 *
!* Short name of the program: Gaussian.c                           *
!* Author: Liu Xinran                                              *
!* Date:   Fri , 05/10/1996                                        *
!* A brief description of the program:    This program proceeds a  *
!*                                                                 *
!*******************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
/*#define DISP*/
#define LEN 64 /*length of the dimension of this matrix */

float absolute(float x)
  {
    if (x>=0)
      return x;
    else
      return -x;
  }

void set_val_A(float a[LEN][LEN])
  {
    int i,j;
    long now;

    srand(time(&now)%37);

    for (i=0;i<LEN;i++)
      for (j=0;j<LEN;j++)
/*        a[i][j]=(float)(i*3*i+j)+100;*/
        a[i][j]=(float)(rand()%40);
  }

void set_val_B(float b[LEN])
  {
   int i;

   for (i=0;i<LEN;i++)
     b[i]=i+50;
  }

void display_A(float a[LEN][LEN])
  {
    int i,j;

    for (i=0;i<LEN;i++)
      {
        for (j=0;j<LEN;j++)
          printf("%10f",a[i][j]);
        printf("\n");
      }
  }

void display_B(float b[LEN])
  {
    int i;

    for (i=0;i<LEN;i++)
      printf("%f\n",b[i]);
  }

void gaussian(float a[LEN][LEN],float b[LEN])
  {
    float max_value,m,temp;
    int i,j,k,l,max_line;

    for (i=0;i<LEN;i++)
      {
        #ifdef DISP
        display_A(a);
        printf("\n");
        #endif
        max_line=i;
        max_value=a[i][i];

        for (j=i+1;j<LEN;j++)
          if (absolute(max_value)<absolute(a[j][i]))
            {
              max_line=j;
              max_value=a[j][i];
            }
        #ifdef DISP
        printf("max_value = %f\n",max_value);
        printf("i = %d\n",i);
        #endif
        if (absolute(max_value)==0)
          {
            printf("The coefficient matrix can not be solved\n");
            exit(0);
          }

        if (max_line!=i)
          {
            for (k=i;k<LEN;k++)
              {
                temp=a[i][k];
                a[i][k]=a[max_line][k];
                a[max_line][k]=temp;
              }
            temp=b[i];
            b[i]=b[max_line];
            b[max_line]=temp;
          }
        #ifdef DISP
        display_A(a);
        printf("\n");
        #endif
        for (k=i+1;k<LEN;k++)
          {
            m=a[k][i]/max_value;
            for (l=i;l<LEN;l++)
              a[k][l]=a[k][l]-a[i][l]*m;
            #ifdef DISP
            display_A(a);
            printf("\n");
            #endif
            b[k]=b[k]-b[i]*m;
          }
      }
  }

void solve(float a[LEN][LEN],float b[LEN],float x[LEN])
  {
    int i,j;
    float temp;

    for (i=LEN-1;i>=0;i--)
      {
        temp=0;
        for (j=i+1;j<=LEN-1;j++)
          temp=temp+a[i][j]*x[j];
        x[i]=(b[i]-temp)/a[i][i];
      }
  }

void display(float x[LEN])
  {
    int i;

    for (i=0;i<LEN;i++)
      printf("X [%d] = %f\n",i,x[i]);
  }

main(int argc,char *argv[])
  {
    float a[LEN][LEN],b[LEN],x[LEN];

    set_val_A(a);
    set_val_B(b);
    gaussian(a,b);
    solve(a,b,x);
    display(x);
  }
