#include <stdlib.h>
#include "db.h"

extern PTR_FILE fi;

static void del_blob_and_bfnd(PTR_BLOB,PTR_BLOB);
static int is_leftmost_blob(PTR_BLOB);
static int is_head_ll_list(PTR_BFND,PTR_LLND);
static void del_leftmost_son(PTR_BFND);
static void del_llnd_head(PTR_BFND);
static void del_llnd(PTR_LLND,PTR_LLND);
static int is_para_decl_symb(PTR_SYMB);
static int is_func_name(PTR_SYMB);
static int is_null_var_decl(PTR_BLOB);
void del_var_decl_son_list(PTR_BFND);

PTR_SYMB findFuncDeclSymb();

static void
del_blob_and_bfnd(PTR_BLOB pre_blp,PTR_BLOB cur_blp) 
{
	PTR_BLOB        tempblp;
/*	if(blp->next) { /* what if the blp is null ?
		tempbp = blp->ref; 
		blp->ref = blp->next->ref;
		tempblp = blp->next; 
		blp->next = blp->next->next;
	}
*/
	tempblp = cur_blp;
	pre_blp->next = cur_blp->next;
	return;
}

static int
is_leftmost_blob(PTR_BLOB blp)
{
return(blp->ref->control_parent->entry.Template.bl_ptr1 == blp ? 1 : 0);
}

static int
is_head_ll_list(PTR_BFND bp, PTR_LLND lp)
{
return(bp->entry.Template.ll_ptr1 == lp ? 1 : 0);
}

static void
del_leftmost_son(PTR_BFND parent)
{
 PTR_BLOB temp_blp;

    temp_blp = parent->entry.Template.bl_ptr1;
    parent->entry.Template.bl_ptr1 = parent->entry.Template.bl_ptr1->next;
    /* free(temp_blp); CANNOT BE DONE NOW ! */
}

static void
del_llnd_head(PTR_BFND parent)
{
 PTR_LLND temp_ll;

    temp_ll = parent->entry.Template.ll_ptr1;
    parent->entry.Template.ll_ptr1 = parent->entry.Template.ll_ptr1->entry.list.next;
    /* free(temp_ll);  CANNOT BE DONE NOW ! */
}

static void 
del_llnd(PTR_LLND pre_lp,PTR_LLND cur_lp) 
{
	PTR_LLND	templp;

	templp = cur_lp;
	pre_lp = cur_lp->entry.list.next;
/*	if(lp->entry.list.next) {
		templp = lp->entry.list.item; 
		lp->entry.list.item = lp->entry.list.next->entry.list.item;
		templp = lp->entry.list.next; 
		lp->entry.list.next = lp->entry.list.next->entry.list.next;
	}
*/}

static int 
is_para_decl_symb(PTR_SYMB symb)
{
	return( symb->entry.var_decl.local == INPUT ||
	    symb->entry.var_decl.local == OUTPUT ||
	    symb->entry.var_decl.local == IO ?
	    1 : 0 );
}

static int
is_func_name(PTR_SYMB symb)
{
        return( symb->variant == FUNCTION_NAME ? 1 : 0 );
}

static int 
is_null_var_decl(PTR_BLOB blp)
{
	return(blp->ref->variant == VAR_DECL && 
	    blp->ref->entry.Template.ll_ptr1 == NULL ? 1 : 0 ); /* where is the definition of NULL */
}

void 
del_var_decl_son_list(PTR_BFND bp)
{
        PTR_BLOB preblp,tmpblp; /* a temporary blob */
        PTR_LLND prelp, tmplp;  /* a temporary llnd */

        for(tmpblp = bp->entry.Template.bl_ptr1; 
	    tmpblp && tmpblp->ref->variant == VAR_DECL ; 
	    preblp = tmpblp, tmpblp = tmpblp->next) {
                for(tmplp = tmpblp->ref->entry.Template.ll_ptr1 ; 
		    tmplp; 
		    prelp = tmplp, tmplp = tmplp->entry.list.next)
                    if(is_para_decl_symb(tmplp->entry.list.item->entry.var_ref.symbol) ||
		       is_func_name(tmplp->entry.list.item->entry.var_ref.symbol)) { 
			if(is_head_ll_list(tmpblp->ref,tmplp))
			  del_llnd_head(tmpblp->ref);
			else
			  del_llnd(prelp,tmplp);
		    }
                if(is_null_var_decl(tmpblp)) {
		    if(is_leftmost_blob(tmpblp))
			del_leftmost_son(tmpblp->ref->control_parent);
		    else
			del_blob_and_bfnd(preblp,tmpblp);
		}
        }
        return;
}

PTR_SYMB
findFuncDeclSymb(PTR_SYMB funcName)
{
 PTR_SYMB	tempSymb;

 for(tempSymb = fi->head_symb; tempSymb; tempSymb = tempSymb->thread)
	if ((tempSymb->variant == PROCEDURE_NAME ||
	    tempSymb->variant == ROUTINE_NAME ||
	    tempSymb->variant == FUNCTION_NAME) &&
	    ! strcmp(tempSymb->ident, funcName->ident))
	   return(tempSymb);
 return(NULL);

}
